SystemOrganization addCategory: #'FEaturesFInder-Core'!
SystemOrganization addCategory: #'FEaturesFInder-Definitions'!
SystemOrganization addCategory: #'FEaturesFInder-Visitors'!

!RBMethodNode methodsFor: '*featuresfinder' stamp: 'OzC 12/17/2010 20:43'!
hasVarName: aName
"Error new signal: 'foo'."
	^ self allDefinedVariables includes: aName! !

!RBReturnNode methodsFor: '*featuresfinder' stamp: 'OzC 8/8/2011 17:54'!
categorizeRef: fd in: refCtg
	refCtg categorize: fd inCtg: #aliasing "#'potential-aliasing'"! !

!Matrix class methodsFor: '*featuresfinder' stamp: 'OzC 12/2/2010 17:05'!
newFromArrays: arrays
	|matrix|
	matrix:= self rows: arrays size columns: (arrays at: 1)  size.
	1 to: arrays size do: [:i|
		1 to: (arrays at: i) size do: [:j | matrix at: i at: j put: ((arrays at: i) at: j)]].
	^ matrix! !

!Matrix class methodsFor: '*featuresfinder' stamp: 'OzC 11/26/2010 14:36'!
newFromTransposedArrays: arrays
	|matrix|
	matrix:= self rows: (arrays at: 1) size columns: arrays size.
	1 to: arrays size do: [:i|
		1 to: (arrays at: i) size do: [:j | matrix at: j at: i put: ((arrays at: i) at: j)]].
	^ matrix! !

!Matrix methodsFor: '*featuresfinder' stamp: 'OzC 11/26/2010 14:51'!
asArrays
	|arrays|
	arrays := OrderedCollection new.
	1 to: nrows do: [:i | arrays add: (contents copyFrom:  ((ncols*(i-1)) + 1) to: (i*ncols ))].
	^ arrays asArray! !

!String methodsFor: '*featuresfinder' stamp: 'OzC 8/27/2011 17:48'!
hasSubString: str
	^ (self findString: str ) > 0! !

!String methodsFor: '*featuresfinder' stamp: 'OzC 1/11/2011 20:33'!
matchNamesUntilLast: other
	|ss so|
	ss := self findTokens: '-'.
	so:=  other findTokens: '-'.
	((ss size = 1) and: [((ss at: 1) = (so at: 1)) and: [so size = 2]]) ifTrue: [^ true].
	((so size = 1) and: [((so at: 1) = (ss at: 1)) and: [ss size = 2]]) ifTrue: [^ true].
	ss size = so size ifFalse:[^ false].
	1 to: (ss size -1) do: [:i | (ss at: i) = (so at: i) ifFalse: [^ false]].
	^ true! !

!String methodsFor: '*featuresfinder' stamp: 'OzC 12/14/2010 13:01'!
matchPkgName: pkgName
	^ self = pkgName or: [self,'-*' match: pkgName ]! !

!FileStream class methodsFor: '*featuresfinder' stamp: 'OzC 11/26/2010 17:59'!
readAndRewriteTransposedCsv: fileName
	self writeAsCsv:  (Matrix newFromTransposedArrays: (self readFromCsv: fileName)) asArrays 
		 on: fileName,'2'  ! !

!FileStream class methodsFor: '*featuresfinder' stamp: 'OzC 11/26/2010 18:27'!
readFromCsv: fileName 
	|file arrays|
	file:=self readOnlyFileNamed: fileName .
	arrays := OrderedCollection new.
	file withDelimiter: Character cr do: [:line | arrays add: (line findTokens: ',')].
	^ arrays
	
	"|file arrays flag| 
	file:=self readOnlyFileNamed: fileName .
	flag := true.
	arrays := OrderedCollection new.
	file withDelimiter: Character cr do: [:line | 
		flag ifTrue: [ |badStr line2| 
			badStr:= 'Fox, Goose, and Grain'.
			line2 := line copyReplaceTokens: badStr with: 'Fox Goose Grain'.
			arrays add: (line2 findTokens: ',').
			flag := false.
			] ifFalse:[
		arrays add: (line findTokens: ',').
		]].
	^ arrays"
	! !

!FileStream class methodsFor: '*featuresfinder' stamp: 'OzC 11/25/2010 12:50'!
writeAsCsv: ls on: fileName
	^ self forceNewFileNamed: fileName do: [:stream |
		ls do: [:ss | stream nextPutAll:  ss asCommaString withoutQuoting ; cr]]! !

!MCClassDefinition methodsFor: '*featuresfinder' stamp: 'OzC 11/22/2010 20:08'!
depthOfInheritanceIn: mcVersion
	|def|
	(Smalltalk includesKey: self superclassName) ifTrue: [ ^ 1 + (Smalltalk at: self superclassName) allSuperclasses size].
	def := mcVersion atClsDef: self superclassName.
	def  ifNotNil:  [^ 1 + (def depthOfInheritanceIn:  mcVersion)].
	^ 1 + Object allSuperclasses size. 
	! !

!MCClassDefinition methodsFor: '*featuresfinder' stamp: 'OzC 11/16/2010 11:31'!
isPureClsDef 
	^ true! !

!MCClassDefinition methodsFor: '*featuresfinder' stamp: 'OzC 12/21/2011 12:04'!
isTestCaseIn: mcVersion
	"true, if this class is <: TestCase (or its name contains 'Test', whether its superClass cant be traceable) "
	|superCls|
	superclassName asString = 'TestCase' ifTrue: [^ true].
	superCls := mcVersion atClsDef: superclassName.
	superCls ifNotNil: [^ superCls isTestCaseIn: mcVersion].
	(Smalltalk includesKey: superclassName) ifTrue: [ ^ (Smalltalk at: self superclassName) allSuperclasses includes: TestCase].
	^ '*Test*' match: name
	
	
	! !

RBProgramNodeVisitor subclass: #FDataVisitor
	instanceVariableNames: 'def dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Visitors'!

!FDataVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 11/9/2010 17:35'!
on: dict
	^ self new dict: dict.! !

!FDataVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 11/10/2010 13:06'!
parseOnRB: source
	[^ RBParser parseMethod: source] on: Error do: [:e | Transcript cr; show: e].
	^ RBParser parseMethod: 'notValidMethodFailToParse'! !

!FDataVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 11/9/2010 17:33'!
def: aMthDef
	def:= aMthDef ! !

!FDataVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 11/9/2010 17:34'!
dict: aDict
	dict :=aDict ! !

!FDataVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 11/10/2010 13:06'!
visit: source
	source acceptVisitor: self.! !

FDataVisitor subclass: #FIdentifierVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Visitors'!

!FIdentifierVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 11/10/2010 11:28'!
acceptVariableNode: varNode
	
	dict keysAndValuesDo: [:id :ls |
		varNode token value = id asString ifTrue: 
			[ ls add: (FIdentifierDef newFrom: def andParentExpr: varNode parent) ]]
	
	! !

FDataVisitor subclass: #FMessageVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Visitors'!

!FMessageVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 11/9/2010 17:19'!
acceptMessageNode: msgNode
	super acceptMessageNode: msgNode.

	dict keysAndValuesDo: [:selector :ls |
		selector = msgNode selector ifTrue: [ ls add: (FMessageDef newFrom: def andMsg: msgNode) ]
		]! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 12/14/2010 13:12'!
allClassesMatchingProjectName: pkgName
	"TOO SLOW - not used :: We assume that projects have just one version, the last one"
	|ls|
	ls := OrderedCollection new.
	self projects do: [ :project | |last|
		last := project versions last.
		pkgName = ((last name findTokens: '-') at: 1) ifTrue: [ls addAll: last classes]] "Not tested!!!!"
		displayingProgress: 'Getting all classes of ',pkgName .
	^  ls
	
"	self projects do: [ :pjt | |last|
		last:=  pjt versions last.
		(pkgName ,'*' match: last name) ifTrue: [^ last]].
	^ nil."
 

! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/2/2010 23:15'!
allImplementorsOfs: selectors
	| dict |
	dict := Dictionary newFrom: (selectors collect: [:selector| selector -> OrderedCollection new]).
	self allImplementorsOn: dict.
	^ dict select: #notEmpty 
	! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/2/2010 18:34'!
allImplementorsOn: dict
	projects do: [:project | project versions do: [:version| version mcVersion allImplementorsOn: dict] ] 
			  displayingProgress: 'searching implementors'.! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/9/2010 17:59'!
allReferencesOfs: ids
	| dict |
	dict := Dictionary newFrom: (ids collect: [:selector| selector -> OrderedCollection new]).
	self allReferencesOn: dict.
	^ dict select: #notEmpty ! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/9/2010 17:47'!
allReferencesOn: dict
	projects do: [:project | project versions do: [:version| version mcVersion allReferencesOn: dict] ] 
			  displayingProgress: 'searching references'.! !

!EcoSystem methodsFor: '*featuresfinder-filtering' stamp: 'OzC 1/11/2011 16:40'!
allRepitedProject
	^( self filterSimiliarNames: ( (projects collect: [:p | (p name findTokens: '.') at:1 ]) asArray sort) ) asArray sort! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/9/2010 16:20'!
allSendersAndImplementorsOfs: selectors
	| sdict idict |
	sdict := Dictionary newFrom: (selectors collect: [:selector| selector -> OrderedCollection new]).
	idict := Dictionary newFrom: (selectors collect: [:selector| selector -> OrderedCollection new]) .
	self allSendersOn: sdict andImplementorsOn: idict.
	^  {sdict . idict } collect: [:dict | dict select: #notEmpty] ! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/2/2010 23:14'!
allSendersOfs: selectors
	| dict |
	dict := Dictionary newFrom: (selectors collect: [:selector| selector -> OrderedCollection new]).
	self allSendersOn: dict.
	^ dict select: #notEmpty
	
	! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/8/2010 18:50'!
allSendersOn: dict
	(projects "asArray copyFrom: 40 to: 50") do: [:project | project versions do: [:version| version mcVersion allSendersOn: dict] ] 	
			  displayingProgress: 'searching senders'.! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/8/2010 20:24'!
allSendersOn: sdict andImplementorsOn: idict
	projects  do: [:project | project versions do: [:version| version mcVersion allSendersOn: sdict andImplementorsOn: idict] ] 	
			  displayingProgress: 'searching senders & implementors'.! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/10/2010 12:22'!
allSndImplofs: selectors andRefs: ids
	| sdict idict vdict|
	sdict := Dictionary newFrom: (selectors collect: [:selector| selector -> OrderedCollection new]).
	idict := Dictionary newFrom: (selectors collect: [:selector| selector -> OrderedCollection new]) .
	vdict := Dictionary newFrom: (ids collect: [:id| id -> OrderedCollection new]) .
	self allSndOn: sdict implOn: idict refOn: vdict .
	^  {sdict . idict . vdict } collect: [:dict | dict select: #notEmpty] ! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 11/17/2010 18:25'!
allSndOn: sdict implOn:  idict  refOn: vdict
	projects  do: [:project | project versions do: [:version| version mcVersion allSndOn: sdict implOn: idict refOn: vdict]] 	
		displayingProgress: 'searching senders, implementors & references'.! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 1/12/2011 03:12'!
collectCompactData	
							"	1 		2 		3 		4 		5 			6 			7 		 	8"
	"collectDefaultData -> name[str] nolc[#] mths[#] clss[#] avg-non[#] max-non[#] avg-dit[#] max-dit[#]"		
	|dd ds first|
	dd := self collectDefaultData.
	first := dd removeFirst asOrderedCollection .
	first addLast: 'names'.	first at: 1 put: 'pkgName'.
	ds := OrderedCollection new.
	((dd inject: Dictionary new into: [:dict :ls | |pkgName data|
		pkgName := ((ls at: 1) findTokens: '-') at: 1.
		data:=(dict at: pkgName ifAbsentPut: [{0 . 0 . 0 . 0 . 0 . 0 . 0 . OrderedCollection new}]).
		data last add:( ls at: 1). "name"
		{1 . 2 . 3 } do: [:i | data at: i put: (data at: i) + (ls at: (i+1))]. " nolc . mths . clss" 							"VERIFIED"
		{4 . 6} do: [ :i | data at: i put: (  (data at: i) + ( (ls at: (i+1)) * (ls at:( (i//2)+1 )) )  )     ]. "avg-non . avg-dit"	"VERIFIED"
		{5 . 7} do: [ :i | data at: i put: ((ls at: (i+1)) max: (data at: i))]. "max-non . max-dit" 							"VERIFIED"
		dict]) collect: [:data | {4 . 6} do: [:i | data at:i put: ( (data at:(i//2)) = 0 ifTrue: [0] ifFalse:[ (data at: i)/(data at: (i//2)) ] )] . data ]) 
					keysAndValuesDo: [:pkgName :rest | |cs|
						cs := rest asOrderedCollection .
						cs addFirst: pkgName .
						ds add: cs asArray].
	ds addFirst: first asArray.
	^ ds! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 1/12/2011 03:12'!
collectDefaultData
	|data|
	data := OrderedCollection new.
	projects do: [:project | project versions do: [:version | data add: version collectDefaultData]] 
			  displayingProgress: 'collecting default data'.
	data addFirst: {'name' . 'nolc' . 'mths' . 'clss' . 'avg-non' . 'max-non' . 'avg-dit' . 'max-dit'}.
	^ data! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 12/14/2010 13:06'!
collectNumberOfClasses 
	"TOO SLOW, not used"
	|projectNames matrix|
	
	projectNames :=  #('Chuck' 'Kernel' 'TraitsPreload' 'SystemEditor' 'System' 'JavaConnect' 'SOUL' 'MemoryAccess' 'ObjectFlow' 'Morphic' 'Refactoring' 'Refactory' 'RefactoringEngine' 'ST2JS' 'MinimalMorphic' 'MorphicCore' 'Miro' 'Sonora' 'Orion' 'Famix' 'AutoBugFinder' 'Coral' 'MiniMorphicWrapper' 'MorphicWrappers' 'Moose' 'OrionDevelopment' 'ReverseGeneric' 'Sake' 'Spy' 'Kilauea' 'Tric' 'Traits.test' 'Tests' 'Fractal' 'Capabilities' 'Amqp' 'Athena' 'AthenaS' 'BootStrappedClasses' 'ChangeBox' 'Cell' 'SystemChangeNotification' 'System.test' 'Browseunit' 'BrowseUnit' 'BrowserBooster' 'Base' 'KernelTests' 'DeltaStreams' 'DrDoc' 'EOGlorp' 'EtoyMaker' 'FacetS' 'Graphics' 'Fonts' 'GestionImmo' 'Gtk' 'STicky' 'Installer' 'Intensional' 'InterfaceDiscoverer' 'FracTalk' 'Kerala' 'LibraryImporter' 'Lava' 'LazyRabbit' 'Magritte' 'BinarySavingMC' 'MC2' 'MetaclassTalk' 'Magma tester' 'ExtMetaclasses' 'MethodLoader' 'PBE' 'Mixins' 'MorphicExt' 'Bricks' 'Nile' 'Names' 'ObjectiveC' 'ThingLab' 'Perseus' 'HierarchicalBrowser' 'Package' 'Pepper' 'Backup' 'RPackage' 'RPackageTest' 'Smalltalk2Java' 'SeaBreeze' 'Sails' 'Scl' 'Saphir' 'SelectorNamespace' 'Sentorsa' 'Services' 'ShoreBaseModel' 'SqueakCell' 'Collections' 'TestSmells' 'Classloader' 'VMMaker' 'BobsUI' 'General' 'Balloon3D' 'Vista' 'CSSTemplates' 'Seaside' 'WriteBarrier' 'Information' 'TypePlug' 'Collaborations' 'TraitsOmniBrowserTests').
	
	matrix := Matrix rows: projectNames size columns: 2.
	1 to: matrix rowCount do: [:i | matrix at: i at: 1 put: (projectNames at: i)].
	^ (self collectNumberOfClassesOn: matrix) asArrays! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 12/14/2010 13:06'!
collectNumberOfClassesOn: matrix
	"TOO SLOW - not used"
	1 to: matrix rowCount do: [:i | matrix at: i at: 2 put: (self allClassesMatchingProjectName: (matrix at:i at: 1)) size].
	! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 12/17/2010 20:11'!
collectStdMetricOnDefs
	"We assume that projects have just one version, the last one"
	|nondict ditdict|
	nondict := Dictionary newFrom: (FSource top15Pkgs collect: [:pkgName | pkgName -> OrderedCollection new]).
	ditdict := nondict veryDeepCopy .
	self projects do: [:pjt | |mc pkgName|
		mc := pjt versions last mcVersion.
		pkgName := ((mc package name findTokens: '-') at: 1).
		nondict at: pkgName ifPresent: [:ns | mc collectNONon: ns andDITon: (ditdict at: pkgName ) ].
		] displayingProgress: 'Collecting NON & DIT'.
	
	^ {nondict  . ditdict } collect: [:dict |
		dict keys inject: OrderedCollection new into: [:ls :key | |ds|
		ds := dict at: key.
		ls add: (ds collect: [:d | {key . d} ]).
		ls]]
	
	
	
	
	
	! !

!EcoSystem methodsFor: '*featuresfinder-filtering' stamp: 'OzC 1/11/2011 20:42'!
filterSimiliarNames: names
	|ls|
	ls:= Set new.
	(1 to: (names size - 1)) do: [:i | |old|
		old := names at: i.
		(i+1) to: (names size) do: [:j | |neo|
			neo := names at: j.
			(old matchNamesUntilLast: neo) ifTrue: [ls addAll: {old . neo}]
			].
	] displayingProgress: 'filtering'.
	^ ls
	! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 12/17/2010 20:12'!
printStdMetricOnDefs
	self collectStdMetricOnDefs do: [:metric |
		metric do: [:ar | FileStream writeAsCsv: ar on: 'top15-dit/', ((ar at: 1) at: 1),'.csv']]
	
	
	
	
	
	! !

!EcoSystem methodsFor: '*featuresfinder-collecting' stamp: 'OzC 8/26/2011 22:36'!
selectAllProjectWithTests "may be TOO SLOW"
"	|ls|
	ls := OrderedCollection new.
	projects do: [:pjt  |
		projects last mcVersion
		] displayingProgress: 'collecting all Projects'.
	^ ls"! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 12/2/2010 19:13'!
trackAllSelectors
 ^ FTop loadAllFromEcoSystem: self! !

!EcoSystem methodsFor: '*featuresfinder' stamp: 'OzC 8/15/2011 15:16'!
trackSelectors: selectors
 ^ FTop fromEcoSystem: self 
		load: (selectors isSymbol ifTrue: [FSource perform: selectors] ifFalse: [selectors]) 
		and: {}.! !

!MultiByteFileStream methodsFor: '*featuresfinder' stamp: 'OzC 11/26/2010 17:51'!
withDelimiter: delimiter do: oneArgBlock
	[self atEnd] whileFalse: [ oneArgBlock value: (self nextDelimited: delimiter)].
	"Error new signal: 'foo'"
 ! !

!RBSequenceNode methodsFor: '*featuresfinder' stamp: 'OzC 8/8/2011 17:54'!
categorizeRef: fd in: refctg
	|lastStt ctgName|
	ctgName := #'reading-dummy'.
	lastStt := self statements last.
	(self parent isBlock and: [ lastStt isVariable and: [lastStt token value asSymbol = refctg fname]]) 
		ifTrue:[ctgName := #aliasing "#'potential-aliasing'"].
	refctg categorize: fd  inCtg: ctgName ! !

!Symbol methodsFor: '*featuresfinder' stamp: 'OzC 12/5/2011 12:23'!
isPredicateType
	self isUnary ifFalse: [^false].
	('is#*' match: self) ifFalse: [^false].
	(self at: 3) isUppercase ifFalse: [^false].
	^true
	! !

!Set methodsFor: '*FeaturesFinder' stamp: 'OzC 8/4/2011 20:05'!
addWithResponse: newObject
	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) ifNil: [self atNewIndex: index put: newObject. ^ true].
	^ false! !

MCMethodDefinition subclass: #FMthDef
	instanceVariableNames: 'mcVersion flags clsDefCached'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Definitions'!

!FMthDef methodsFor: 'browse-selection' stamp: 'OzC 8/4/2011 21:38'!
browse
	|browser|
	browser := MCSnapshotBrowser forSnapshot: self mcVersion snapshot.
	self classIsMeta ifTrue: [browser switchBeClass] ifFalse: [browser switchBeInstance].
	browser
		categorySelection: (browser categoryList indexOf: self pkgAsCtgSelection);
		classSelection: (browser classList indexOf: self className);
		protocolSelection: (browser protocolList indexOf: self category);
		methodSelection: (browser methodList indexOf: self selector);
		show
	! !

!FMthDef methodsFor: 'accessing' stamp: 'OzC 1/18/2012 17:58'!
clsDef
	^ clsDefCached ifNil: [clsDefCached := self mcVersion atClsDef: self className]! !

!FMthDef methodsFor: 'accessing' stamp: 'OzC 11/22/2010 12:07'!
flags 	
	^ flags ifNil: [ flags := Dictionary new . ^ flags]! !

!FMthDef methodsFor: 'flags' stamp: 'OzC 8/26/2011 22:43'!
hasTestCase 
	self isTestCase ifTrue: [^ true].
	^ self mcVersion hasTestCase
	! !

!FMthDef methodsFor: 'flags' stamp: 'OzC 11/22/2010 12:47'!
isTestCase 
	^ self flags at: #testCase ifAbsentPut: [ super isTestCaseIn: mcVersion ]! !

!FMthDef methodsFor: 'accessing' stamp: 'OzC 10/28/2010 14:32'!
mcVersion
	^ mcVersion! !

!FMthDef methodsFor: 'accessing' stamp: 'OzC 10/28/2010 14:32'!
mcVersion: anObject
	mcVersion := anObject! !

!FMthDef methodsFor: 'browse-selection' stamp: 'OzC 8/4/2011 21:22'!
pkgAsCtgSelection "TODO:"
	self isExtensionMethod ifTrue: [^ '*Extensions'].
	^ self clsDef category! !

!FMthDef methodsFor: 'accessing' stamp: 'OzC 1/22/2012 15:56'!
projectName 
	^ mcVersion package projectName ! !

!FMthDef methodsFor: 'browse-selection' stamp: 'OzC 8/5/2011 10:03'!
senders
	|sdict|
	sdict := Dictionary newFrom: {self selector -> OrderedCollection new}.
	self mcVersion allSendersOn: sdict.
	^ FTop new loadSnds: sdict  impls: Dictionary new refs: Dictionary new 
	! !

!MCMethodDefinition methodsFor: '*featuresfinder' stamp: 'OzC 2/3/2013 23:23'!
isTestCaseIn: mcVersion
	|cls idx|
	cls:= mcVersion atClsDef: className.
	cls ifNotNil: [^ cls isTestCaseIn: mcVersion].
	(Smalltalk includesKey: cls) ifTrue: [ ^ (Smalltalk at: self superclassName) allSuperclasses includes: TestCase].
	idx:= className indexOfSubCollection: 'Test'.
	idx isZero ifTrue: [^ false].
	^ (className at: idx) isUppercase
! !

!MCMethodDefinition methodsFor: '*featuresfinder' stamp: 'OzC 2/3/2013 22:26'!
isTestMethod
	^ 'test*' match: self selector.! !

!MCMethodDefinition methodsFor: '*featuresfinder' stamp: 'OzC 1/12/2011 03:17'!
nolc
	^ (self source findTokens: String cr) size
	! !

!MCMethodDefinition methodsFor: '*featuresfinder' stamp: 'OzC 11/15/2010 21:53'!
numberOfNodes
	^ (FDataVisitor parseOnRB: self source) allChildren size! !

!RBMessageNode methodsFor: '*featuresfinder' stamp: 'OzC 8/8/2011 17:54'!
categorizeRef: fd in: refCtg
	|ctg p|
	ctg := #'reading-dummy'.
	p:= [:suffix | 
			((FSourceRef  perform: (refCtg fname asLowercase, suffix) asSymbol) 
				includes: self selector)].
			
	(self receiver isKindOf: RBVariableNode) ifTrue:[
		(refCtg fname = self receiver token value) ifTrue: [
			(p value: 'WritingSelectors') ifTrue: [ctg:=#writing].
			(p value: 'ReadingSelectors') ifTrue: [ctg:=#reading].
			] ifFalse: [
			(p value: 'NoAliasingSelectors') ifFalse: [ctg:=#aliasing "#'potential-aliasing'" ]
			]
		].
		
	refCtg categorize: fd inCtg: ctg	! !

Random subclass: #RandomWoR
	instanceVariableNames: 'currents max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Definitions'!

!RandomWoR methodsFor: 'as yet unclassified' stamp: 'OzC 8/17/2011 19:10'!
currents 
	^ currents ! !

!RandomWoR methodsFor: 'as yet unclassified' stamp: 'OzC 8/17/2011 18:53'!
initialize 
	super initialize .
	currents := OrderedCollection new.
	max := 0.! !

!RandomWoR methodsFor: 'as yet unclassified' stamp: 'OzC 8/17/2011 18:50'!
maxRange: aInteger
	max:= aInteger .! !

!RandomWoR methodsFor: 'as yet unclassified' stamp: 'OzC 8/17/2011 18:58'!
nextInt
	|num|
	max < 1 ifTrue: [Error new signal: 'MaxRange has not been setted.'].
	[num:= self nextInt: max] doWhileTrue: [currents includes: num].
	^ currents add: num.
	
! !

!MCTraitDefinition methodsFor: '*featuresfinder' stamp: 'OzC 3/7/2012 23:00'!
isPureClsDef 
	^ false! !

!MethodReference methodsFor: '*featuresfinder' stamp: 'OzC 10/19/2010 17:39'!
hasValidSender
	^ self isValid and: [ self actualClass isTrait not]! !

!RBVariableNode methodsFor: '*featuresfinder' stamp: 'OzC 12/17/2010 20:29'!
isLocallyBound
	^ parent hasVarName: self name
	! !

!MCDefinition methodsFor: '*featuresfinder' stamp: 'OzC 11/16/2010 11:31'!
isPureClsDef
	^ false! !

!RBAssignmentNode methodsFor: '*featuresfinder' stamp: 'OzC 11/15/2010 16:28'!
categorizeRef: fd in: refCtg
	refCtg categorize: fd inCtg: #aliasing! !

!RBArrayNode methodsFor: '*featuresfinder' stamp: 'OzC 8/8/2011 17:53'!
categorizeRef: fd in: refCtg
	refCtg categorize: fd inCtg: #aliasing "#'potential-aliasing'  "! !

!RBProgramNode methodsFor: '*featuresfinder' stamp: 'OzC 12/17/2010 20:43'!
hasVarName: varName
	^ parent hasVarName: varName ! !

!EcoProjectVersion methodsFor: '*featuresfinder' stamp: 'OzC 1/12/2011 03:14'!
collectDefaultData
	"return -> name[str] nolc[#] mths[#] clss[#] non-avg[#] non-max[#] dit-avg[#] dit-max[#]"
	|data mc|
	mc := self mcVersion .
	data:= OrderedCollection newFrom: {self name . mc nolc. self methods size . self classes size}.
	data addAll: mc nonAvgMax .
	data addAll: mc ditAvgMax  .
	^ data asArray ! !

!EcoProjectVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/15/2010 21:24'!
sizeInKB
	^ (StandardFileStream readOnlyFileNamed: self folder , '/', self name , '.mcz') size / 1024
	! !

Object subclass: #FDataDef
	instanceVariableNames: 'expr mth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Definitions'!

!FDataDef methodsFor: 'comparing' stamp: 'OzC 10/6/2010 22:27'!
<= other
	^ self printString <= other printString ! !

!FDataDef methodsFor: 'categorizing' stamp: 'OzC 8/9/2011 16:10'!
addOnPkgCtg: dict
	|ctg|
	ctg:= FSource cachedPkgCtg at: self senderProjectName ifAbsent: [^ self].
	self isTestCase ifTrue: [ctg:= #Tests ] .
	(dict at: ctg) add: self.! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/15/2010 19:57'!
args 
	^ expr arguments asArray! !

!FDataDef methodsFor: 'categorizing' stamp: 'OzC 8/25/2011 16:03'!
countOnPkg: dict
	|pkg count|
	pkg := self senderProjectName.
	count := dict at: pkg ifAbsentPut: [0].
	dict at: pkg put: (1 + count).	
	"Error new signal: 'halt'"! !

!FDataDef methodsFor: 'categorizing' stamp: 'OzC 1/14/2011 11:18'!
countOnPkgCtg: dict
	|ctg|
	ctg:= FSource cachedPkgCtg at: self senderProjectName ifAbsent: [^ self].
	self isTestCase ifTrue: [ctg:= #Tests ] .
	dict at: ctg put: (1 + dict at: ctg)	! !

!FDataDef methodsFor: 'categorizing' stamp: 'OzC 8/9/2011 16:28'!
countProjectCtg: dict
	|ctg pjt|
	pjt := self senderProjectName.
	ctg:= FSource cachedPkgCtg at: pjt ifAbsent: [^ self].
	self isTestCase ifTrue: [ctg:= #Tests ] .
	(dict at: ctg) add: pjt.! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 10/2/2010 12:09'!
expr 
	^ expr! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/9/2010 17:12'!
expr: anExpr
	expr := anExpr ! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 1/17/2011 15:25'!
hasReceiverToken: name
	^ self receiver token value = name! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 1/17/2011 15:56'!
hasSuperAsReceiver
	^ self hasReceiverToken:  'super'! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 8/26/2011 22:41'!
hasTestCase
	^ mth hasTestCase! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 10/27/2010 10:58'!
inside
	^ mth selector! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 1/23/2012 11:33'!
isIdentifier 
	^ false! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 1/17/2011 15:21'!
isInTop1000
	^ FSource cachedPkgCtg includesKey: self senderProjectName ! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 1/23/2012 11:33'!
isMessage 
	^ false! !

!FDataDef methodsFor: 'testing' stamp: 'OzC 11/22/2010 10:58'!
isTestCase
	^ mth isTestCase! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/8/2010 16:30'!
mth: aMethod
	mth := aMethod.! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/22/2010 12:20'!
mthDef
	^ mth! !

!FDataDef methodsFor: 'printing' stamp: 'OzC 8/4/2011 18:26'!
printOn: stream
"[sender>>inside ]"
stream "nextPutAll: 'FD[' ;" print: self sender ; nextPutAll: '>>' ; print: self inside
		"; nextPutAll:  ' | ' ; print: self receiver" "; nextPut: $]"! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/15/2010 19:57'!
receiver 
	^ expr receiver ! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/8/2010 16:29'!
sender
	^ mth className 
	! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 11/9/2010 17:10'!
senderPkgName
	^ mth  mcVersion package name! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 1/5/2011 15:16'!
senderProjectName
	^ (self senderPkgName findTokens: '-') at: 1 ! !

!FDataDef methodsFor: 'accessing' stamp: 'OzC 10/27/2010 10:58'!
source
	^ mth source! !

FDataDef subclass: #FIdentifierDef
	instanceVariableNames: 'featureCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Definitions'!

!FIdentifierDef class methodsFor: 'as yet unclassified' stamp: 'OzC 11/10/2010 11:30'!
newFrom: mthdef andParentExpr: expr
	^ self new mth: mthdef ; expr: expr! !

!FIdentifierDef methodsFor: 'as yet unclassified' stamp: 'OzC 8/19/2011 11:28'!
featureCategory
	^ 'Smalltalk-' , featureCategory ! !

!FIdentifierDef methodsFor: 'accessing' stamp: 'OzC 8/19/2011 11:27'!
featureCategory: anObject
	featureCategory := anObject! !

!FIdentifierDef methodsFor: 'as yet unclassified' stamp: 'OzC 1/22/2012 23:07'!
isIdentifier 
	^ true! !

FDataDef subclass: #FMessageDef
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Definitions'!

!FMessageDef class methodsFor: 'as yet unclassified' stamp: 'OzC 11/10/2010 11:34'!
newFrom: mthdef andMsg: msgNode
	^ self new  mth: mthdef ; selector: msgNode selector ; expr: msgNode.
! !

!FMessageDef methodsFor: 'as yet unclassified' stamp: 'OzC 8/19/2011 14:27'!
featureCategory 
	(FSource class allSelectorsInCategory: 'selectors') do: [:source|
		((FSource perform: source) includes: selector) ifTrue: [ ^ source first: (source size - 9) ] ].
	"Error new signal: (selector , ' with out feature category')"
	^ 'dummy'! !

!FMessageDef methodsFor: 'testing' stamp: 'OzC 1/22/2012 23:07'!
isMessage 
	^true! !

!FMessageDef methodsFor: 'testing' stamp: 'OzC 11/9/2010 16:59'!
isValid
	^ self receiver isNil not! !

!FMessageDef methodsFor: 'accessing' stamp: 'OzC 11/9/2010 17:09'!
selector: aSym  
	selector := aSym ! !

!FMessageDef methodsFor: 'as yet unclassified' stamp: 'OzC 1/19/2012 10:22'!
trackedSelector
	^ self expr selector! !

Object subclass: #FDataSource
	instanceVariableNames: 'expr feature fdata comments kind unsafeToSafe locally removable effort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Definitions'!

!FDataSource class methodsFor: 'as yet unclassified' stamp: 'OzC 8/4/2011 18:36'!
newFrom: fdata
	^ self new fdata: fdata! !

!FDataSource methodsFor: 'comparing' stamp: 'OzC 8/4/2011 18:56'!
<= another
  ^ self asString <= another asString! !

!FDataSource methodsFor: 'comparing' stamp: 'OzC 8/4/2011 18:57'!
= another
	^ self asString = another asString 
	! !

!FDataSource methodsFor: 'mergingcomments' stamp: 'RomainRobbes 8/27/2011 18:55'!
add: o
	self convert.
	o convert.
	comments addAll: o comments.
	effort addAll: o effort.
	feature addAll: o feature.
	kind addAll: o kind.
	locally addAll: o locally.
	removable addAll: o removable.
	unsafeToSafe addAll: o unsafeToSafe.! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:04'!
comments
	^ comments! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 13:02'!
comments: text
	comments := text! !

!FDataSource methodsFor: 'mergingcomments' stamp: 'RomainRobbes 8/27/2011 19:14'!
convert
	(comments isKindOf: OrderedCollection) ifTrue: [^ self].
	#(comments effort feature kind locally removable unsafeToSafe) do: [:e | | coll |
		coll := (OrderedCollection with: (self perform: e)) reject: #isNil.
		self perform: e asMutator with: coll.]! !

!FDataSource methodsFor: 'accessing' stamp: 'RomainRobbes 8/23/2011 20:13'!
effort
	^ effort! !

!FDataSource methodsFor: 'accessing' stamp: 'RomainRobbes 8/27/2011 19:15'!
effort: eff
	effort := eff! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:04'!
expr
	^ expr! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:04'!
expr: anObject
	expr := anObject! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/4/2011 18:45'!
fdata 	
	^ fdata! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:04'!
fdata1: anObject
	fdata := anObject! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 11:07'!
fdata: fd
	fdata := fd.
	expr := fd expr.
	feature := fd featureCategory.
	! !

!FDataSource methodsFor: 'printing' stamp: 'OzC 8/19/2011 11:37'!
feature 
	^ feature ! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:04'!
feature: anObject
	feature := anObject! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
kind
	^ kind! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
kind: anObject
	kind := anObject! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
locallly
	^ locallly! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
locallly: anObject
	locallly := anObject! !

!FDataSource methodsFor: 'accessing' stamp: 'RomainRobbes 8/27/2011 19:08'!
locally
	^ locally! !

!FDataSource methodsFor: 'accessing' stamp: 'RomainRobbes 8/27/2011 19:16'!
locally: loc 
	locally := loc! !

!FDataSource methodsFor: 'printing' stamp: 'OzC 8/4/2011 18:33'!
printOn: stream
	"pkg sender>>inside \n source"
	stream print: fdata senderPkgName ; 
			nextPutAll: ' ';
			print: fdata ;
			cr ;
			print: fdata mthDef source 
! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
removable
	^ removable! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
removable: anObject
	removable := anObject! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
unsafeToSafe
	^ unsafeToSafe! !

!FDataSource methodsFor: 'accessing' stamp: 'OzC 8/19/2011 22:05'!
unsafeToSafe: anObject
	unsafeToSafe := anObject! !

Object subclass: #FFeatures
	instanceVariableNames: 'fname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FFeatures methodsFor: 'comparing' stamp: 'OzC 10/15/2010 22:55'!
<= other
	^ fname <= other fname! !

!FFeatures methodsFor: 'accessing' stamp: 'OzC 10/15/2010 22:55'!
fname
	^ fname
	
! !

!FFeatures methodsFor: 'accessing' stamp: 'OzC 10/15/2010 22:55'!
fname: aName
	fname := aName ! !

FFeatures subclass: #FXFeatures
	instanceVariableNames: 'fdata receivers senders args blacklist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

FXFeatures class
	instanceVariableNames: 'dicts testPkgs'!

FXFeatures class
	instanceVariableNames: 'dicts testPkgs'!

FXFeatures subclass: #ArgCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!ArgCategory methodsFor: 'initialization' stamp: 'OzC 10/19/2010 11:35'!
initializeAllRest 
	blacklist add: #args! !

!ArgCategory methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:25'!
newBlacklist 
	^ blacklist union: {#args}! !

!ArgCategory methodsFor: 'printing' stamp: 'OzC 10/19/2010 01:20'!
printOn: aStream
	"FAC[pkg: m classes, n refs]"
	aStream nextPutAll: 'FAC[' ; print: fname ; nextPutAll: ': ' ; print: fdata size ; nextPutAll: 'refs]'! !

FXFeatures subclass: #FClass
	instanceVariableNames: 'classRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FClass methodsFor: 'initialization' stamp: 'OzC 10/19/2010 11:35'!
initializeAllRest 
	blacklist add: #senders! !

!FClass methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:24'!
newBlacklist 
	^ blacklist union: {#senders}! !

!FClass methodsFor: 'printing' stamp: 'OzC 10/10/2010 23:12'!
printOn: aStream
	"FC[cls: n refs]"
	aStream nextPutAll: 'FC[' ; print: fname ; nextPutAll: ': ' ; print: fdata size ; nextPutAll: 'refs]'! !

FXFeatures subclass: #FPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FPackage methodsFor: 'accessing' stamp: 'OzC 10/18/2010 14:50'!
classes 
	^ senders ! !

!FPackage methodsFor: 'initialization' stamp: 'OzC 10/19/2010 11:35'!
initializeAllRest 
	blacklist add: #senders! !

!FPackage methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:23'!
newBlacklist 
	^ blacklist union: {#senders}! !

!FPackage methodsFor: 'printing' stamp: 'OzC 10/18/2010 14:50'!
printOn: aStream
	"FP[pkg: m classes, n refs]"
	aStream nextPutAll: 'FP[' ; print: fname ; nextPutAll: ': ' ;print: self classes size ; nextPutAll: 'classes, '; print: fdata size ; nextPutAll: 'refs]'! !

!FPackage methodsFor: 'as yet unclassified' stamp: 'OzC 10/28/2010 01:04'!
senderCategoryClass 
	^ FClass ! !

!FPackage methodsFor: 'as yet unclassified' stamp: 'OzC 10/28/2010 01:03'!
senderGrpName: fd
	^ fd sender! !

FXFeatures subclass: #FSelector
	instanceVariableNames: 'implemetors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FSelector methodsFor: 'collecting-data' stamp: 'OzC 1/18/2011 16:55'!
allDangerousProjectNames 
	|names|
	"For instCrt, subClsCrt(2), clsDel [NOT POSSIBLE], spClsUpd(2), objRefUpd(2)"
	names:=Set newFrom: (receivers at: #stexpr ifAbsent: [RcvCategory new]) allProjectNames.
	names addAll: (receivers at: #varname  ifAbsent: [RcvCategory new]) allProjectNames.
	
	"For subClsCrt(2) -small-, spClsUpd(2) -large-, objRefUpd(2) -large-"
	names addAll: (args at: #stexpr ifAbsent: [RcvCategory new]) allProjectNames.
	names addAll: (args at: #varname  ifAbsent: [RcvCategory new]) allProjectNames.
	
	"For (all -small- ) perform:  , mthRem , mthAdd
	names:=Set newFrom: (args at: #stexpr ifAbsent: [RcvCategory new]) allProjectNames.
	names addAll: (args at: #varname  ifAbsent: [RcvCategory new]) allProjectNames."
		
	^ names! !

!FSelector methodsFor: 'collecting-data' stamp: 'OzC 1/28/2011 19:06'!
allDangerousSenders 
	|names|
	"For instCrt, subClsCrt(2), clsDel , spClsUpd(2), objRefUpd (2)
	names:=Set newFrom: ((receivers at: #stexpr ifAbsent: [RcvCategory new]) fdata ). 
	names addAll: ((receivers at: #varname  ifAbsent: [RcvCategory new]) fdata )."
	
	"For subClsCrt(2) -small-, spClsUpd(2) -large-, objRefUpd(2) -large-
	names addAll: ((args at: #stexpr ifAbsent: [RcvCategory new]) fdata ).
	names addAll: ((args at: #varname  ifAbsent: [RcvCategory new]) fdata )."
	
	"For (all -small- )  objFldUpd, perform: , mthRem , mthAdd"
	names:=Set newFrom: ((args at: #stexpr ifAbsent: [RcvCategory new]) fdata ).
	names addAll: ((args at: #varname  ifAbsent: [RcvCategory new]) fdata ).
		
	^ names! !

!FSelector methodsFor: 'accessing' stamp: 'OzC 10/15/2010 23:57'!
allImplementors 
	^ implemetors inject: OrderedCollection new into: [:ls :i | ls addAll: i classes . ls] ! !

!FSelector methodsFor: 'collecting-data' stamp: 'OzC 12/6/2010 12:29'!
collectReceiverDataOn: dict
	receivers keysAndValuesDo: [:key :rc | |bodyDict|
		bodyDict:= dict at: key.
		bodyDict  at: #ttotal put: (bodyDict at: #ttotal) + rc fdata size.
		bodyDict  at: #ttests put: (bodyDict at: #ttests) + rc testCases size.
		bodyDict keysAndValuesDo: [:pkgName :n |
			(#(#ttotal #ttests) includes: pkgName) 
				ifFalse:[ bodyDict at: pkgName put: n + (rc allSenderRefsFrom: pkgName) size]]]! !

!FSelector methodsFor: 'collecting-data' stamp: 'OzC 12/6/2010 12:29'!
collectSenderDataOn: dict
	dict keysAndValuesDo: [:pkgName :bodyDict | |snds|
		snds:= self allSenderRefsFrom: pkgName.
		bodyDict at: #ttotal put: (bodyDict at: #ttotal) + (snds size).
		bodyDict at: #ttests put: (bodyDict at: #ttests) + (snds select: #isTestCase) size.
		].
	"senders keysAndValuesDo: [:pkgName :fp | 
		dict keysAndValuesDo: [:pkg :bodyDict| 
			(pkg , '*' match: pkgName) ifTrue: [
				bodyDict  at: #ttotal put: (bodyDict at: #ttotal) + fp fdata size.
				bodyDict  at: #ttests put: (bodyDict at: #ttests) + fp testCases size]]"! !

!FSelector methodsFor: 'accessing' stamp: 'OzC 10/15/2010 23:25'!
implemetors
	^ implemetors! !

!FSelector methodsFor: 'initialization' stamp: 'OzC 10/18/2010 13:35'!
initializeAllRest  
	implemetors := Dictionary new.! !

!FSelector methodsFor: 'loading-data' stamp: 'OzC 11/2/2010 23:41'!
loadImplementors: refs
 	refs do: [:mthdef | |pkgName |
		pkgName := mthdef mcVersion package name.
		(implemetors at: pkgName ifAbsentPut: [IPackage new fname: pkgName]) classes add: mthdef className.
		]! !

!FSelector methodsFor: 'loading-data' stamp: 'OzC 11/15/2010 15:02'!
loadSenders: refs
	refs do: [:fd | self addFData: fd]! !

!FSelector methodsFor: 'printing' stamp: 'OzC 10/20/2010 14:47'!
printOn: aStream
	"FS[#selector: n refs]"
	aStream nextPutAll: 'FS[' ; print: fname ; nextPutAll: ' ' 
							 ; print: self allImplementors size ; nextPutAll: ' implemetors, ' 
							 ; print: fdata size ; nextPutAll: ' refs]' 
! !

!FSelector methodsFor: 'split' stamp: 'OzC 8/15/2011 20:14'!
safeObjFldRead
	^ self selectByArg: {#number . #string . #symbol} withName: 's-ObjFldRead'! !

!FSelector methodsFor: 'sampling' stamp: 'OzC 8/19/2011 12:13'!
sampling23
	^ self sortedByFeature: (self sampleWoR: 23)! !

!FSelector methodsFor: 'sampling' stamp: 'OzC 8/19/2011 12:48'!
sampling262
	^ self sortedByFeature: (self sampleWoR: 262 and: [:src | 
		src fdata isInTop1000 
			and: [src fdata senderPkgName ~= 'JavaScript' ]]) "Do I really need this?"! !

!FSelector methodsFor: 'split' stamp: 'OzC 8/15/2011 20:13'!
selectByArg: list withName: nam
	|rf|
	rf:= self class new fname: nam.
	list do: [:grp |
		rf loadSenders:  (self args at: grp) fdata
	].
	^ rf! !

!FSelector methodsFor: 'split' stamp: 'OzC 8/17/2011 12:46'!
selectByPkgCtg: ctg
	|fx|
	fx:= self class new fname: self fname.
	fx loadSenders: (self allDataInPkgCtg at: ctg). "may be slow"
	^ fx
	
	! !

!FSelector methodsFor: 'split' stamp: 'OzC 8/15/2011 20:19'!
unsafeObjFldRead
	^ self selectByArg: {#varname . #stexpr} withName: 'u-ObjFldRead'! !

!FXFeatures class methodsFor: 'as yet unclassified' stamp: 'OzC 8/26/2011 14:29'!
collectData
	|dict|
	dict := (dicts at: 1) veryDeepCopy.
	2 to: dicts size do: [:i| |current|
		current := dicts at: i.
		current keysAndValuesDo: [:k :v| | sub |
			sub := (dict at: k).
			v keysAndValuesDo:  [:k2 :v2 | 
				sub at: k2 put: (v2 + (sub at: k2 ifPresent: [:val | val] ifAbsent: [0])). 
				]
			]
		].
	^ dict! !

!FXFeatures class methodsFor: 'as yet unclassified' stamp: 'OzC 8/26/2011 14:21'!
dicts 
	dicts ifNil: [dicts := OrderedCollection new].
	^ dicts.! !

!FXFeatures class methodsFor: 'as yet unclassified' stamp: 'OzC 8/26/2011 23:08'!
printCollectData
	|ls dict|
	ls := OrderedCollection new.
	dict := self collectData .
	FSource top1000WithCategories pairsDo: [:package :cat |
		(dict at: cat) at: package ifAbsentPut: 0.
	].
	self testPkgs do: [:package | 
		(dict at: #Tests) at: package ifAbsentPut: 0.
		].
	dict keysAndValuesDo: [:ctg :pkgs | |pkgNames pkgRefs|
		ls add: {ctg}.
		pkgNames := OrderedCollection new.
		pkgRefs := OrderedCollection new.
		pkgs keysAndValuesDo: [:pkgName :size |
			pkgNames add: pkgName . pkgRefs add: size].
		ls add: pkgNames .
		ls add: pkgRefs .
		].
	FileStream writeAsCsv: ls on: 'csvs/pkg-allIn1.csv' ! !

!FXFeatures class methodsFor: 'as yet unclassified' stamp: 'OzC 8/26/2011 23:08'!
testPkgs 
	testPkgs ifNil: [testPkgs := Set new].
	^ testPkgs.! !

!FXFeatures methodsFor: 'adding-data' stamp: 'OzC 11/15/2010 18:51'!
addFData: fd
	fdata add: fd.
	
	(blacklist includes: #senders) ifFalse: [self categorizeInSender: fd].
	(blacklist includes: #receivers) ifFalse: [self categorizeInReceiver: fd].
	(blacklist includes: #args) ifFalse: [self categorizeInArg: fd].

	! !

!FXFeatures methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:20'!
addToBlacklist: aSym
	blacklist := blacklist add: aSym ! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/9/2011 16:27'!
allDataInPkgCtg
	|  bodyDict|	
		bodyDict := Dictionary newFrom: (FSource pkgCategories collect: [:ctg | ctg -> OrderedCollection  new]).	
		fdata do: [:fd | fd addOnPkgCtg: bodyDict].
		^ bodyDict . 		! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/17/2011 12:30'!
allMethodNames "keep backward compatibility"
	^ fdata inject: Set new into: [:ss :fd | ss add: fd asString .ss] ! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/4/2011 18:59'!
allMthSources 
	^ fdata inject: Set new into: [:ls :fd | ls add: fd mthDef source . ls]! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/26/2011 23:01'!
allPkgWithTestCases
	|pkgs tests|
	pkgs := OrderedCollection new.
	tests := Set new.
	fdata do: [:fd | |pkgName|
		pkgName:= fd senderProjectName .
		(pkgs includes: pkgName) ifFalse: [
			fd hasTestCase ifTrue:[tests add: pkgName]].
		] displayingProgress: 'collecting packages with tests'.
	^ tests ! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/8/2011 18:46'!
allProjectNames
	"|names|
	names := OrderedCollection new.
	fdata do: [:fd| |pkgName|
			pkgName := fd senderProjectName. 
			(names includes: pkgName) ifFalse: [names add: pkgName]] displayingProgress: 'generating names'.
	^ names "
	^ fdata inject: Set new into: [:ss :f | ss add: f senderProjectName .ss]! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 12/14/2010 13:02'!
allSenderRefsFrom: name 
	"Dangeours method"
	^ self senders inject: OrderedCollection new into: [:ls :sender | |pkgName|
		(sender isKindOf: FPackage) ifFalse: [Error new signal: 'allSenderRefsFrom: in not a FPackage'].
		pkgName := sender fname.
		(name matchPkgName: pkgName ) ifTrue: [ls addAll: sender fdata] . ls] ! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/4/2011 20:08'!
allSources "returns all distint sources sorted from (self allMthSources) as FDataSource instances"
	|ss|
	ss := SortedCollection new.
	fdata inject: Set new into: [:ls :fd | 
		(ls addWithResponse:  fd mthDef source) ifTrue: [ss add: (FDataSource newFrom: fd)] . ls]. "totally ugly hack!!"
	^ ss! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 11/24/2010 12:38'!
args 	
	^ args! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 10/18/2010 13:52'!
blacklist 
	^ blacklist ! !

!FXFeatures methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:20'!
blacklist: aSet
	blacklist :=  aSet  ! !

!FXFeatures methodsFor: 'categorizing' stamp: 'OzC 1/28/2011 16:14'!
categorizeInArg: fd
		
	|firstArg ctg|
	firstArg := fd args size = 0 ifTrue:[^ self] ifFalse:[fd args at: 1].
	
	(firstArg isKindOf: RBVariableNode) ifTrue:[ |token|
		
		"(args at: #varname ifAbsentPut: [ArgCategory new fname: #varname ; blacklist: self newBlacklist ])
			addFData: fd. 
			
		"token := firstArg  token value.
		(token = 'self' or: [token = 'super']) ifTrue: [
			(args at: #self ifAbsentPut: [ArgCategory new fname: #self ; blacklist: self newBlacklist])
				addFData: fd. 
			^ self
			].
		(firstArg isLocallyBound not and: [(token at: 1) isUppercase]) ifTrue: [ 
			 (args at: #clsname ifAbsentPut: [ArgCategory new fname: #clsname ; blacklist: self newBlacklist])
			 	addFData: fd. 
			^ self
			].
		(args at: #varname ifAbsentPut: [ArgCategory new fname: #varname ;  blacklist: self newBlacklist])
		 	addFData: fd.
			
			"--- END"
			
		^ self
		].
	(firstArg isKindOf: RBLiteralValueNode) ifTrue:[ |literal|
		literal:= firstArg token value.
		literal isString ifFalse: [
			(args at: #number ifAbsentPut: [ArgCategory new fname: #number ; blacklist: self newBlacklist])
				addFData: fd. 
			^ self	
			].
		literal isSymbol ifTrue: [
			(args at: #symbol ifAbsentPut: [ArgCategory new fname: #symbol ; blacklist: self newBlacklist])
				addFData: fd. 
			^ self
			].
		(args at: #string ifAbsentPut: [ArgCategory new fname: #string ; blacklist: self newBlacklist])
			addFData: fd. 
		^ self		
		].
	(args at: #stexpr ifAbsentPut: [ArgCategory new fname: #stexpr ; blacklist: self newBlacklist])
		addFData: fd. ! !

!FXFeatures methodsFor: 'categorizing' stamp: 'OzC 1/17/2011 15:09'!
categorizeInReceiver: fd
	|receiverExpr|
	receiverExpr := fd receiver.
	
	(receiverExpr isKindOf: RBVariableNode) ifTrue:[ |token|
		token := receiverExpr token value.
		(token = 'self' or: [token = 'super']) ifTrue: [
			(receivers at: #self ifAbsentPut: [RcvCategory new fname: #self ; blacklist: self newBlacklist])
				addFData: fd. 
			^ self
			].
		(receiverExpr isLocallyBound not and: [(token at: 1) isUppercase]) ifTrue: [ "It is a global variable -> a class name"
			 (receivers at: #clsname ifAbsentPut: [RcvCategory new fname: #clsname ; blacklist: self newBlacklist])
			 	addFData: fd. 
			^ self
			].
		(receivers at: #varname ifAbsentPut: [RcvCategory new fname: #varname ;  blacklist: self newBlacklist])
		 	addFData: fd. 
		^ self		
		].
	(receivers at: #stexpr ifAbsentPut: [RcvCategory new fname: #stexpr ;blacklist: self newBlacklist])
		addFData: fd. ! !

!FXFeatures methodsFor: 'categorizing' stamp: 'OzC 10/28/2010 01:01'!
categorizeInSender: fd
	|name|
	name := self senderGrpName: fd.
	(senders at: name ifAbsentPut: [self senderCategoryClass new fname: name; blacklist: self newBlacklist])
		addFData: fd.
	
	! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 12/7/2010 10:41'!
collectData: data withTestsOn: dict
	data keysAndValuesDo: [:key :rc | |bodyDict testsDict|
		bodyDict:= dict at: key.
		testsDict := dict at: (key , '-tests') asSymbol .
		
		bodyDict  at: #ttotal put: (bodyDict at: #ttotal) + rc fdata size.
		bodyDict  at: #ttests put: (bodyDict at: #ttests) + rc testCases size.
		
		testsDict  at: #ttotal put: (bodyDict at: #ttests) .
		testsDict  at: #ttests put: (bodyDict at: #ttests) .
		
		bodyDict keysAndValuesDo: [:pkgName :n |
			(#(#ttotal #ttests) includes: pkgName) 
				ifFalse:[  |snds|
					snds:= rc allSenderRefsFrom: pkgName.
					bodyDict at: pkgName put: n + snds size.
					testsDict at: pkgName put: (testsDict at: pkgName) + (snds select: #isTestCase) size]]]! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/25/2011 15:58'!
collectPkgUsageByCtg
	|dict|
	dict := self allDataInPkgCtg .		
	dict keysAndValuesDo: [ :key :fds| 
		dict at: key put: (fds inject: Dictionary new into: [:d :f | f countOnPkg: d . d])].
	^ dict.! !

!FXFeatures methodsFor: 'collecting-data' stamp: 'OzC 8/9/2011 16:27'!
countProjectCtg
	|  bodyDict|	
		bodyDict := Dictionary newFrom: (FSource pkgCategories collect: [:ctg | ctg -> Set new]).	
		fdata do: [:fd | fd countProjectCtg: bodyDict].
		^ bodyDict . 		! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 10/18/2010 13:32'!
fdata
	"fdata ifNil: [fdata :=SortedCollection new]."
	^ fdata ! !

!FXFeatures methodsFor: 'initialization' stamp: 'OzC 10/18/2010 13:51'!
initialize 
	fdata := SortedCollection new.
	receivers := Dictionary new.
	senders := Dictionary new.
	args := Dictionary new.
	blacklist := Set new.
	self initializeAllRest! !

!FXFeatures methodsFor: 'initialization' stamp: 'OzC 10/10/2010 23:01'!
initializeAllRest 
	"If necessary, it must be defined in subclasses"! !

!FXFeatures methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:21'!
newBlacklist
	^ blacklist ! !

!FXFeatures methodsFor: 'printing' stamp: 'OzC 8/25/2011 17:06'!
printPkgUsageByCtg: name
	|ls dict|
	ls := OrderedCollection new.
	dict := self collectPkgUsageByCtg 	.
	dict keysAndValuesDo: [:ctg :pkgs | |pkgNames pkgRefs|
		ls add: {ctg}.
		pkgNames := OrderedCollection new.
		pkgRefs := OrderedCollection new.
		pkgs keysAndValuesDo: [:pkgName :size |
			pkgNames add: pkgName . pkgRefs add: size].
		ls add: pkgNames .
		ls add: pkgRefs .
		].
	FileStream writeAsCsv: ls on: 'csvs/pkg-', name , '.csv' ! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 11/24/2010 12:37'!
receivers 
	^ receivers ! !

!FXFeatures methodsFor: 'sampling' stamp: 'OzC 8/17/2011 19:11'!
sampleWoR: n
	"take a sample from fdata array with out replacement"
	|sources length  randomzer|
	sources := self allSources.
	randomzer := RandomWoR new maxRange: sources size.
	^ (1 to: n) inject: SortedCollection new into: [:ss :i |
		ss add: (sources at: randomzer nextInt) . ss
		] 

	! !

!FXFeatures methodsFor: 'sampling' stamp: 'OzC 8/17/2011 19:18'!
sampleWoR: n and: predicate
	"take a sample from fdata array with out replacement that satisfy the predicate"
	|sources length  randomzer sampling counter|
	sources := self allSources.
	randomzer := RandomWoR new maxRange: sources size.
	sampling := SortedCollection new.
	counter := 0.
	[n > counter] whileTrue: [ |idx|
		idx := randomzer nextInt.
		(predicate value: (sources at: idx) ) ifTrue: [
			sampling  add: (sources at: idx).
			counter:= counter + 1.
			] .
		] .
	^ sampling 

	! !

!FXFeatures methodsFor: 'sender-categories' stamp: 'OzC 10/28/2010 01:02'!
senderCategoryClass 
	^ FPackage ! !

!FXFeatures methodsFor: 'sender-categories' stamp: 'OzC 11/9/2010 17:10'!
senderGrpName: fd
	^ fd senderPkgName ! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 11/24/2010 12:37'!
senders 	
	^ senders! !

!FXFeatures methodsFor: 'sampling' stamp: 'OzC 8/19/2011 12:44'!
sortedByFeature: sample
	^ sample inject: Dictionary new into: [:dic :ss |
			(dic at: (ss feature) ifAbsentPut:[SortedCollection new]) add: ss .
		dic]	! !

!FXFeatures methodsFor: 'accessing' stamp: 'OzC 11/24/2010 12:36'!
testCases
	^ fdata select: #isTestCase! !

FXFeatures subclass: #RcvCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!RcvCategory methodsFor: 'initialization' stamp: 'OzC 10/19/2010 11:36'!
initializeAllRest 
	blacklist add: #receivers! !

!RcvCategory methodsFor: 'blacklist' stamp: 'OzC 10/19/2010 02:22'!
newBlacklist 
	^ blacklist union: {#receivers}! !

!RcvCategory methodsFor: 'printing' stamp: 'OzC 10/19/2010 01:20'!
printOn: aStream
	"FP[pkg: m classes, n refs]"
	aStream nextPutAll: 'FRC[' ; print: fname ; nextPutAll: ': ' ; print: fdata size ; nextPutAll: 'refs]'! !

FXFeatures subclass: #RefCategory
	instanceVariableNames: 'refs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 11/15/2010 19:06'!
addFData: fd
	super addFData: fd.
	(blacklist includes: #refs) ifFalse: [self categorizeInRef: fd]! !

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 8/19/2011 11:28'!
categorize: fd inCtg: ctg
	(refs at: ctg ifAbsentPut: [	|container|
		((ctg = #aliasing) or: [(ctg = #'reading-dummy') "or: [ctg = #'potential-aliasing']"]) 
			ifTrue: [container := RefCategory new fname: ctg ; blacklist: self newBlacklist].
	 	((ctg = #reading) or: [ctg = #writing]) ifTrue: [
			container := RefCategory new fname: ctg ; blacklist: (Set newFrom: {#receivers . #refs})].     
		container 
	]) addFData: fd.
	
	fd featureCategory: ctg! !

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 11/15/2010 18:54'!
categorizeInRef: fd
	fd expr categorizeRef: fd in: self 
	! !

!RefCategory methodsFor: 'testing' stamp: 'OzC 8/8/2011 15:53'!
checkCtgConsistency
	^ (((refs at: #reading) fdata collect: [:fd | fd expr selector]) asSet 
		intersection: 
			FSourceRef  smalltalkWritingSelectors asSet) size  == 0! !

!RefCategory methodsFor: 'collecting-data' stamp: 'OzC 8/8/2011 18:47'!
collectReferenceData
	|dict body |
	dict := Dictionary new.
	body := {#ttotal . #ttests} , (self allProjectNames).
	 #(#'reading-dummy' #aliasing "#'potential-aliasing'" #reading #writing)
		do: [:key | dict at: key put: (Dictionary newFrom: (body veryDeepCopy collect: [:k| k->0]))].
	self collectReferenceDataOn: dict.
	^ dict ! !

!RefCategory methodsFor: 'collecting-data' stamp: 'OzC 12/6/2010 12:30'!
collectReferenceDataOn: dict
	refs keysAndValuesDo: [:key :rfc | |bodyDict|
		bodyDict:= dict at: key.
		bodyDict  at: #ttotal put: (bodyDict at: #ttotal) + rfc fdata size.
		bodyDict  at: #ttests put: (bodyDict at: #ttests) + rfc testCases size.
		bodyDict keysAndValuesDo: [:pkgName :n |
			(#(#ttotal #ttests) includes: pkgName) 
				ifFalse:[ bodyDict at: pkgName put: n + (rfc allSenderRefsFrom: pkgName) size]]]! !

!RefCategory methodsFor: 'collecting-data' stamp: 'OzC 12/7/2010 10:42'!
collectReferenceDataWithTests
	|dict body |
	dict := Dictionary new.
	body := {#ttotal . #ttests} , (self allProjectNames).
	 #(#'reading-dummy' #'reading-dummy-tests' #aliasing #'aliasing-tests' #'potential-aliasing' #'potential-aliasing-tests' 
		#reading #'reading-tests' #writing #'writing-tests')
		do: [:key | dict at: key put: (Dictionary newFrom: (body veryDeepCopy collect: [:k| k->0]))].
	self collectData: refs withTestsOn: dict.
	^ dict ! !

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 11/15/2010 18:57'!
initializeAllRest 
	refs := Dictionary new.
	blacklist addAll: {#receivers . #args}! !

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 8/8/2011 17:43'!
loadRefs: fds
	fds do: [ :fd | self addFData: fd] displayingProgress: 'loading references for:', fname! !

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 11/15/2010 19:09'!
newBlacklist 
	^ blacklist union: {#refs}! !

!RefCategory methodsFor: 'printing' stamp: 'OzC 11/15/2010 17:17'!
printOn: aStream
	"IP[pkgName: n classes]"	
	aStream nextPutAll: 'RC[' ; print: fname ; nextPutAll: ': ' ;print: fdata size ; nextPutAll: 'refs]'! !

!RefCategory methodsFor: 'as yet unclassified' stamp: 'OzC 11/15/2010 16:08'!
refs 
	^ refs! !

!RefCategory methodsFor: 'sampling' stamp: 'OzC 8/19/2011 12:11'!
sampling
	^ self sortedByFeature: (self sampleWoR: 92 and: [:fd | fd feature ~= 'Smalltalk-reading-dummy' ]) 
			! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/15/2011 18:40'!
select: criteria
	|rf|
	rf:= self class new fname: #Smalltalk.
	rf loadRefs: (fdata select: criteria ).
	^ rf
	
		! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/9/2011 18:22'!
selectByArg: list
	|rf|
	rf:= self class new fname: 'Smalltalk'.
	list do: [:grp |
		rf loadRefs: (self args at: grp) fdata
	].
	^ rf
	
		! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/17/2011 12:52'!
selectByPkgCtg: ctg
	|fx|
	fx:= self class new fname: 'Smalltalk'.
	fx loadRefs: (self allDataInPkgCtg at: ctg). "may be slow"
	^ fx! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/9/2011 18:17'!
selectByUnSafeArg
	^ self selectByArg: {#stexpr . #varname}
	
		! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/15/2011 19:15'!
selectRdSafe
	fname = #reading ifFalse: [Error new signal: 'Wrong ref. category, must be reading'].
	^ (self selectByArg: {#symbol . #self . #string}) 
		loadRefs: (fdata select: [:fd|fd args size = 0]) ; 
		yourself.
	
		! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/15/2011 18:58'!
selectRdUnsafe
	fname = #reading ifFalse: [Error new signal: 'Wrong ref. category, must be reading'].
	^ self selectByArg: {#stexpr . #varname}
	
		! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/15/2011 18:57'!
selectWrSafe
	fname = #writing ifFalse: [Error new signal: 'Wrong ref. category, must be writing'].
	^ self selectByArg: {#symbol . #clsname . #string}
	
		! !

!RefCategory methodsFor: 'split' stamp: 'OzC 8/15/2011 18:57'!
selectWrUnsafe
	fname = #writing ifFalse: [Error new signal: 'Wrong ref. category, must be writing'].
	^ self selectByArg: {#stexpr . #varname}
	
		! !

FFeatures subclass: #IPackage
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!IPackage methodsFor: 'accessing' stamp: 'OzC 10/15/2010 23:19'!
classes
	^ classes! !

!IPackage methodsFor: 'initialization' stamp: 'OzC 10/15/2010 23:54'!
initialize 
	classes := OrderedCollection new.! !

!IPackage methodsFor: 'printing' stamp: 'OzC 10/15/2010 23:20'!
printOn: aStream
	"IP[pkgName: n classes]"	
	aStream nextPutAll: 'FP[' ; print: fname ; nextPutAll: ': ' ;print: classes size ; nextPutAll: 'classes]'! !

Object subclass: #FSample
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FSample methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/27/2011 19:01'!
data
	^ data! !

!FSample methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/27/2011 19:01'!
from: fileName
	data := FLMaterializer materializeFromFileNamed: fileName.
	! !

!FSample methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/27/2011 19:06'!
mergeWith: otherFile
	| otherData |
	otherData := (FSample new from: otherFile) data.
	data keysAndValuesDo: [:k :v |
		otherData at: k ifPresent: [:v2 |
				(v asSortedCollection: [:a :b | a fdata printString < b fdata printString])
					with: 	(v2 asSortedCollection: [:a :b | a fdata printString < b fdata printString])
					do: [:this :other | this add: other]
			]
		]! !

!FSample methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/27/2011 19:00'!
writeOn: fileName
	FLMaterializer serialize: data toFileNamed: fileName! !

Object subclass: #FSource
	instanceVariableNames: 'selectors timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

FSource class
	instanceVariableNames: 'cachedPkgCtg'!

FSource class
	instanceVariableNames: 'cachedPkgCtg'!

!FSource class methodsFor: 'util-scripting' stamp: 'OzC 1/29/2011 10:41'!
allInOne
	^  (FSource class allSelectorsInCategory: 'selectors') 
		inject: OrderedCollection new 
		into: [:list :feature | list addAll: (FSource perform: feature) . list] ! !

!FSource class methodsFor: 'accessing' stamp: 'OzC 1/14/2011 10:22'!
cachedPkgCtg 
	cachedPkgCtg ifNil: [ cachedPkgCtg := Dictionary newFromPairs: self top1000WithCategories].
	^ cachedPkgCtg ! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 1/29/2011 21:03'!
classCreationSelectors
	^#(
"#superclass:subclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#superclass:variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#superclass:variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#superclass:variableWordSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#superclass:weakSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
#name:inEnvironment:subclassOf:type:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#name:inEnvironment:subclassOf:type:instanceVariableNames:classVariableNames:poolDictionaries:category:unsafe:"
	)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 1/18/2011 17:03'!
classDeletionSelectors
	^ #(
#removeFromSystem 
#removeFromSystem: 
#removeFromSystemUnlogged
"#removeSubclass:  -->IT IS JUST UNLIKING"
 
"#forgetClass:logged: -->IT IS USED WITH SMALLTALK"
"#removeClassNamed:	-->IT IS USED WITH SMALLTALK"
	)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 1/12/2011 04:22'!
instanceCreationSelectors
	^ #(
	#basicNew 
#basicNew: 
"#initializedInstance 
#new 
#new:"
	)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 11/25/2010 11:04'!
methodAdditionSelectors
^#(
"Behavior>>"
#compile:
 #compile:notifying:
 
"ClassDescripton>>"
#compile:classified: 
#compile:classified:notifying: 
#compile:classified:withStamp:notifying: 
#compile:classified:withStamp:notifying:logSource: 
#compileSilently: 
#compileSilently:classified: 
#compileSilently:classified:notifying:
 
"Behavior>>"
#addSelector:withMethod: 
#addSelector:withMethod:notifying: 
#addSelectorSilently:withMethod:
#basicAddSelector:withMethod:
#methodDictAddSelectorSilently withMethod:
)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 11/25/2010 19:59'!
methodInvocationSelectors
^#(
"ProtoObject>>"
#executeMethod: 
#with:executeMethod: 
#with:with:executeMethod: 
#with:with:with:executeMethod: 
#with:with:with:with:executeMethod:
#withArgs:executeMethod:
 
"Object>>"
#perform:with:
#perform:
#perform:with:with:
#perform:withEnoughArguments:
#perform:orSendTo:
#perform:withArguments:
#perform:with:with:with:
#perform:withArguments:inSuperclass:
 
"CompiledMethod>>"
#valueWithReceiver:arguments: 
)	! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 11/25/2010 19:51'!
methodRemovingSelectors
^ #(
"ClassDescription>>"
#removeSelector:
 
"Behavior>>"
#basicRemoveSelector:
#removeSelectorSilently:
)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 8/15/2011 18:13'!
objectFieldReadingSelectors
^#(
"Object>>"
"#at:"
#instVarAt:
#instVarNamed:
#basicAt:
)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 12/2/2010 19:09'!
objectFieldUpdatingSelectors
^#(
"Object>>"
#instVarAt:put: 
#instVarNamed:put:
#basicAt:put:
)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 1/17/2011 21:06'!
objectUpdatingSelectors
^#(
"ProtoObject>>"
#become: 
 
"Object>>"
#becomeForward:copyHash:
#becomeForward:
#primitiveChangeClassTo:
)! !

!FSource class methodsFor: 'info-lists' stamp: 'OzC 1/14/2011 10:42'!
pkgCategories
	^ #(#LangExt #Tools #App #System #Tests).! !

!FSource class methodsFor: 'info-lists' stamp: 'OzC 8/26/2011 14:55'!
pkgWithTests
	^ #().! !

!FSource class methodsFor: 'util-scripting' stamp: 'OzC 12/2/2010 17:30'!
selectingNumberOfClassesFromFile
	|matrixAll projectNames matrixNOC|
	
	matrixAll := Matrix newFromArrays: ( FileStream readFromCsv: 'csvs/all-data.csv').

	projectNames :=  #('Chuck' 'Kernel' 'TraitsPreload' 'SystemEditor' 'System' 'JavaConnect' 'SOUL' 'MemoryAccess' 'ObjectFlow' 'Morphic' 'Refactoring' 'Refactory' 'RefactoringEngine' 'ST2JS' 'MinimalMorphic' 'MorphicCore' 'Miro' 'Sonora' 'Orion' 'Famix' 'AutoBugFinder' 'Coral' 'MiniMorphicWrapper' 'MorphicWrappers' 'Moose' 'OrionDevelopment' 'ReverseGeneric' 'Sake' 'Spy' 'Kilauea' 'Tric' 'Traits.test' 'Tests' 'Fractal' 'Capabilities' 'Amqp' 'Athena' 'AthenaS' 'BootStrappedClasses' 'ChangeBox' 'Cell' 'SystemChangeNotification' 'System.test' 'Browseunit' 'BrowseUnit' 'BrowserBooster' 'Base' 'KernelTests' 'DeltaStreams' 'DrDoc' 'EOGlorp' 'EtoyMaker' 'FacetS' 'Graphics' 'Fonts' 'GestionImmo' 'Gtk' 'STicky' 'Installer' 'Intensional' 'InterfaceDiscoverer' 'FracTalk' 'Kerala' 'LibraryImporter' 'Lava' 'LazyRabbit' 'Magritte' 'BinarySavingMC' 'MC2' 'MetaclassTalk' 'Magma tester' 'ExtMetaclasses' 'MethodLoader' 'PBE' 'Mixins' 'MorphicExt' 'Bricks' 'Nile' 'Names' 'ObjectiveC' 'ThingLab' 'Perseus' 'HierarchicalBrowser' 'Package' 'Pepper' 'Backup' 'RPackage' 'RPackageTest' 'Smalltalk2Java' 'SeaBreeze' 'Sails' 'Scl' 'Saphir' 'SelectorNamespace' 'Sentorsa' 'Services' 'ShoreBaseModel' 'SqueakCell' 'Collections' 'TestSmells' 'Classloader' 'VMMaker' 'BobsUI' 'General' 'Balloon3D' 'Vista' 'CSSTemplates' 'Seaside' 'WriteBarrier' 'Information' 'TypePlug' 'Collaborations' 'TraitsOmniBrowserTests').
	matrixNOC := Matrix rows: projectNames size columns: 2.
	1 to: matrixNOC rowCount do: [:i | |pkgName|
		pkgName := projectNames at: i.
		matrixNOC at: i at: 1 put: pkgName .
		matrixNOC at: i at: 2 put: (matrixAll at: (matrixAll indexOf: (String lf , pkgName)) x at: 4)].
	
	FileStream writeAsCsv: matrixNOC asArrays on: 'csvs/noc-subClassCreation.csv' ! !

!FSource class methodsFor: 'util-scripting' stamp: 'OzC 12/2/2010 18:40'!
selectingNumberOfMethodsFromFile
	|matrixAll projectNames matrixNOM|
	
	matrixAll := Matrix newFromArrays: ( FileStream readFromCsv: 'csvs/all-data.csv').

	projectNames :=   #('AOStA' 'btb' 'Bytecode' 'Sorrow' 'Tests' 'CodA' 'MorphicExt' 'MinimalMorphic' 'Compiler' 'ByteCode' 'JITCompiledMethods' 'JCompiledMethods' 'AlternativePrototype' 'MethodLoader' 'ThingLab' 'MethodWrappers3.9' 'OpenGL' 'GLMorphic' 'CoverageObjectsAsMethodWrappers' 'Singletons' 'Eg' 'ObjectAsMethodWrapper' 'RPackage' 'Persephone' 'Subjectivity' 'Classloader' 'Kernel' 'Capabilities' 'Sonora' 'Base' 'Traits' 'ChangeList2' 'Tools' 'ChangeSorter' 'PlusTools' 'ByteSurgeon' 'System' 'Green' 'Grease' 'HerdBehavior' 'Goya' 'Magma client' 'MessageCapture' 'SystemEditor' 'MutationTesting' 'CroquetAwareTools' 'Platypus' 'NewCompiler' 'Coverage' 'TraceLibrary' 'Seaside' 'WriteBarrier' 'LibraryImporter' 'Kilauea' 'Tric' 'Traits.test' 'AardWorks' 'SmalltalkP' 'PharoExamples' 'Compiler.test' 'AthenaS' 'Athena' 'Slots' 'AutoBugFinder' 'BootStrappedClasses' 'SelectorNamespace' 'CollectiveBehavior' 'KernelTests' 'Benchmarking' 'Bricks' 'ChangeBoxes' 'Cell' 'SystemChangeNotification' 'System.test' 'Classbox' 'Collaborations' 'Compass' 'Contracts' 'PetitCoral' 'CoverageTestCase' 'DGV' 'DGVwxUI' 'PBE' 'Exupery' 'Famix' 'Faces' 'FameUtil' 'FTP' 'FacetS' 'Formation' 'Phexample' 'Glamour' 'Gofer' 'Gtk' 'STicky' 'InterfaceDiscoverer' 'JavaScript' 'Kerala' 'KVBinding' 'LazyRabbit' 'Goodies' 'Lisp' 'SOUL' 'Soul' 'CAnalyzerOBCommands' 'BinarySavingMC' 'MC2' 'MetaclassTalk' 'Magma tester' 'MyBox' 'BobsUIDevelopment' 'ExtMetaclasses' 'NikoBoxes' 'Spy' 'MinimalMorphicLoader' 'Mondrian' 'CAnalyzer' 'NewInspector' 'Nile' 'Names' 'OB' 'OmniTesting2' 'Ocompletion' 'ObjectFinder' 'InstanceEncoder' 'SqueakNOS' 'PhysicalEtoys' 'Pattern' 'Coral' 'PECOS' 'PierPersistentStore' 'Perseus' 'Package' 'SmaCCDev' 'PersonalSetting' 'RemoteObjects' 'RPackageTest' 'rSTAdd' 'ReacTalk' 'Regex' 'ReverseGeneric' 'RoboSapien' 'Rome' 'Smalltalk2Java' 'SentorsaSeaside' 'Scl' 'SelfEvaluatingObject' 'Sentorsa' 'ShoreComponentsExporters' 'OBTestingGenerator' 'Swazoo' 'SqueakCell' 'LiCoR' 'PrototypeForSqueak' 'VMMakerLoader' 'SOI' 'SOIDavos' 'Vista' 'Seaside2' 'Balloon3D' 'Atom' 'AtomFeed' 'Sextant' 'BT' 'Fractal' 'Refactory' 'RefactoringEngine' 'Actalk' 'Refactoring' 'TraitsOmniBrowserTests' 'Amqp' 'BuildBot' 'BrowseUnit' 'BrowserBooster' 'Cresta' 'Cloudfork' 'SpyWare' 'Genie' 'CSSTemplates' 'CTU' 'Cg' 'CgCroquet' 'Browseunit' 'NewFileInAndOutFormat' 'MiniMorphicWrapper' 'MorphicWrappers' 'Graphics' 'Integration' 'DBus' 'DeltaStreams' 'Debugger' 'DrDoc' 'DrGeoII' 'EBot' 'EasyMorphicGUI' 'EOGlorp' 'EtoyMaker' 'FFI' 'Moose' 'Fame' 'XSLFO' 'Dav' 'GestionImmo' 'Geppetto' 'ISobot' 'SW2Calendar' 'Intensional' 'FracTalk' 'Speech' 'Lava' 'Magritte' 'Games' 'TestsMonticello' 'Monticello.test' 'MonticelloTests' 'Ma base additions' 'Maui' 'Morphic' 'Pica' 'JoeTheMiner' 'MiniActalk' 'Miro' 'Nurikabe' 'O2' 'TraitsUI' 'TraitsOmniBrowser' 'ODE' 'ObjectiveC' 'Pier' 'HierarchicalBrowser' 'Pepper' 'ProcessWrapper' 'EToysTests' 'RSRSS' 'RSRSS2' 'RSS' 'MinorityReport' 'SeaBreeze' 'SqueakPeopleStats' 'SmallWiki2' 'Sails' 'ScriptLoader' 'ScriptLoader11' 'Services' 'ShoreBaseModel' 'Passport' 'Collections' 'TypePlug' 'Network' 'NetworkTests' 'Freezable' 'Polymorph' 'BobsUI' 'Aida' 'XML' 'Information' 'BobsBrowser' 'Browser' 'CLFramework' 'Fonts' 'Smallapack' 'Protocols' 'Pitch Set' 'CodeHolder' 'MorphicCore' 'Sake' 'Packages' 'Tamaris' 'WifiBot' 'FixUnderscores' 'NamespaceTools' 'BabySRE' 'OBLightweightClass' 'OBSubmenusExamples' 'SVI' 'Unstuck' 'ChangeBox' 'FMA' 'Multilingual' 'HTML' 'Keymapping' 'OLE' 'ObjectFlow' 'SmallBrother' 'SwaLint' 'HttpSmalltalkServerPages' 'TestSmells').
	matrixNOM := Matrix rows: projectNames size columns: 2.
	1 to: matrixNOM rowCount do: [:i | |pkgName|
		pkgName := projectNames at: i.
		matrixNOM at: i at: 1 put: pkgName .
		matrixNOM at: i at: 2 put: (matrixAll at: (matrixAll indexOf: (String lf , pkgName)) x at: 3)].
	
	FileStream writeAsCsv: matrixNOM asArrays on: 'csvs/nom-methodAddition.csv' ! !

!FSource class methodsFor: 'util-scripting' stamp: 'OzC 1/28/2011 02:39'!
someAloneScripts

"|dict|
dict:= Dictionary newFrom: (FSource pkgCategories collect: [:c | c -> 0]).
2 to: 2000 by: 2 do: [:i | |ctg|
	ctg:= FSource top1000WithCategories at: i.
	dict at: ctg put: (1+ dict at: ctg)].
dict."

"(fdata select: #hasSuperAsReceiver) size"

"(fdata select: [:f | (f args at: 1) token value = 'self' ])"

"((self selectPkgCategory: #App) selectors at: 1 )allDangerousSenders size"

"|s|
s:=Set newFrom: (args at: #self ifAbsent: [FXFeatures new]) fdata.
s addAll: (receivers at: #self ifAbsent: [FXFeatures new]) fdata.
s size"

"|ft|
ft := (self selectTheseWithFilter: FSource methodInvocationSelectors          )  selectPkgCategory: #App.
{'mth' -> ft allMethodNames size.
'mth-unsafe' ->ft allDangerousMethodNames size}"


"|nv|
nv := OrderedCollection new.
	 (self select: [:src |  
	([(RBParser parseMethod: src value) allChildren size >= 9] on: Error do: [ nv add: src value. false]) ])."

"self select: [:i | (RBParser parseMethod: i value) body statements last value isKindOf: RBVariableNode ]"

"self select: [:i | (RBParser parseMethod: i value) body lastIsReturn not]"
! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 11/24/2010 11:20'!
subclassCreationSelectors
	^ #(
	#addSubclass:
#newSubclass 
#subclass: 
#subclass:instanceVariableNames: 
#subclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#subclass:uses: 
#subclass:uses:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#variableByteSubclass:uses:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#variableSubclass:uses:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#variableWordSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#variableWordSubclass:uses:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#weakSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: 
#weakSubclass:uses:instanceVariableNames:classVariableNames:poolDictionaries:category:
	)! !

!FSource class methodsFor: 'selectors' stamp: 'OzC 1/17/2011 21:05'!
superClassUpdatingSelectors
^#(
"Behavior>>"
#superclass:
#superclass:methodDict:format:

"Object>>"

)! !

!FSource class methodsFor: 'info-lists' stamp: 'OzC 1/14/2011 01:30'!
top1000WithCategories 
^#(
#'2340' #'App'

#'.Workbench' #'App'

#'3C' #'App'

#'AardWorks' #'App'

#'AbstractSyntax' #'App'

#'Aconcagua' #'App'

#'Actalk' #'LangExt'

#'Addons' #'App'

#'ADL' #'App'

#'AdvancedRCS' #'App'

#'Aida6.0' #'App'

#'AidaSP' #'App'

#'AKSEAsteroids_01' #'App'

#'Albatross' #'App'

#'Aldeamoret' #'App'

#'Algernon' #'Tools'

#'Alien' #'System'

#'AlienOpenGL' #'App'

#'Amqp' #'App'

#'AnswerNaire' #'App'

#'ANTLR' #'App'

#'AOStA' #'App'

#'Applescript' #'App'

#'APS' #'App'

#'Aquarium' #'App'

#'ArbitraryPrecisionFloat' #'App'

#'ArchiveViewer' #'App'

#'Arduino' #'App'

#'Arimaa' #'App'

#'AST' #'App'

#'AsteriskMonitor' #'App'

#'AsteriskMonitorRepository' #'App'

#'AsteriskMonitorWeb' #'App'

#'Asteroid' #'App'

#'AstroMorphs' #'App'

#'AT' #'App'

#'ATEO' #'App'

#'Athena' #'App'

#'AthenaS' #'App'

#'Atom' #'App'

#'Atomic' #'App'

#'AtomManager' #'App'

#'Aton' #'App'

#'AtonTests' #'Tests'

#'ATTests' #'App'

#'AudioVideoLib' #'App'

#'AuthorshipViewer' #'App'

#'AutomaticMethodCategorizer' #'Tools'

#'AvatoxMooseImporter' #'App'

#'AXAnnouncements' #'App'

#'BabySRE' #'App'

#'Backgammon' #'App'

#'BackTalkNG' #'LangExt'

#'BackupMaker' #'App'

#'Balloon' #'App'

#'Balloon3D' #'App'

#'Barry' #'App'

#'Base' #'System'

#'Battleship' #'App'

#'Beach' #'App'

#'BeachLogin' #'App'

#'BeachStore' #'App'

#'BeachTable' #'App'

#'BehaviorMockup' #'LangExt'

#'Benchmarking' #'App'

#'BFAV' #'App'

#'Bibliothouris' #'App'

#'BinaryStreamTools' #'App'

#'BipBip' #'App'

#'BkbagMagmaTesting' #'App'

#'BkbagSeasideTesting' #'App'

#'BL' #'App'

#'Blackjack(21)' #'App'

#'Blog' #'App'

#'Blowfish' #'App'

#'BmdEmail' #'App'

#'BobsBrowser' #'Tools'

#'BobsUI' #'App'

#'BobsUIDevelopment' #'App'

#'Boggle' #'App'

#'BookMorphandFriends' #'App'

#'BotGridSimulator' #'App'

#'BowWave' #'App'

#'Boxy' #'App'

#'Breakout' #'App'

#'BreakOut' #'App'

#'Browser' #'Tools'

#'BrowserBooster' #'Tools'

#'BrowseUnit' #'Tools'

#'BT' #'App'

#'btb' #'App'

#'BugsBeansAndToads' #'App'

#'ByteSurgeon' #'LangExt'

#'CAG' #'App'

#'CairoGraphics' #'App'

#'CAnalyzer' #'App'

#'CanvasGraph' #'App'

#'Capabilities' #'App'

#'CardsGame' #'App'

#'CASE' #'App'

#'CassandraClient' #'App'

#'Cassowary' #'App'

#'CCSE' #'App'

#'CellStore' #'App'

#'Cg' #'App'

#'CgCroquet' #'App'

#'Chalten' #'App'

#'ChaltenChristian' #'App'

#'ChaltenCore' #'App'

#'ChaltenFilter' #'App'

#'ChaltenGregorian' #'App'

#'ChaltenHebrew' #'App'

#'ChaltenIslamic' #'App'

#'ChaltenJulian' #'App'

#'ChaltenZone' #'App'

#'ChangeBox' #'LangExt'

#'ChangeBoxes' #'LangExt'

#'ChangeCompletion' #'App'

#'ChangeList2' #'Tools'

#'ChangeSorter' #'Tools'

#'ChatClientFEL' #'App'

#'ChatServerCore' #'App'

#'ChatServerWeb' #'App'

#'Checkers' #'App'

#'Chess' #'App'

#'Choose' #'App'

#'Christo' #'App'

#'Chronos' #'App'

#'Chuck' #'App'

#'CircularReasoning' #'App'

#'Citezen' #'App'

#'Classbox' #'LangExt'

#'ClassboxBrowser' #'Tools'

#'ClassboxJava' #'LangExt'

#'Classifications2' #'App'

#'Classloader' #'System'

#'Classroom' #'App'

#'CLFramework' #'App'

#'Client' #'App'

#'Cloudfork' #'App'

#'ClueTip' #'App'

#'CodA' #'App'

#'CodeFu' #'App'

#'CodeHolder' #'Tools'

#'CodeScope' #'LangExt'

#'CodeVis' #'App'

#'Collaborations' #'App'

#'Collections' #'System'

#'CollectionsTests' #'Tests'

#'ColorLegend' #'App'

#'ColorMap' #'App'

#'COM' #'App'

#'Comet' #'App'

#'Comix' #'App'

#'CommandShell' #'App'

#'Compass' #'Tools'

#'Compiler' #'System'

#'Compression' #'App'

#'Conman' #'App'

#'Connectors' #'App'

#'Conrad' #'App'

#'ConsCell' #'App'

#'Contracts' #'App'

#'Coral' #'App'

#'CoreWar' #'App'

#'CorruptVM' #'LangExt'

#'CouchDB' #'App'

#'Course' #'App'

#'Coverage' #'App'

#'CoverageTestCase' #'App'

#'CreativeCorsetry' #'App'

#'Cresta' #'App'

#'Critical' #'App'

#'Croaker' #'App'

#'Croquet' #'App'

#'CroquetBag' #'App'

#'Crorev' #'App'

#'Cryptography' #'App'

#'cs2340' #'App'

#'CS410ap' #'App'

#'CS510ap' #'App'

#'CS520' #'App'

#'cs598' #'App'

#'CS598rej' #'App'

#'CSS' #'App'

#'CssMenu' #'App'

#'CSSTemplates' #'App'

#'CSSTests' #'App'

#'CstMessengerSupport' #'App'

#'CSV' #'App'

#'CTU' #'App'

#'CurlHack' #'App'

#'CurlPlugin' #'App'

#'Currency' #'App'

#'CW' #'App'

#'DA' #'App'

#'Daap' #'App'

#'Daliot' #'App'

#'DatePicker' #'App'

#'Dav' #'App'

#'DBus' #'App'

#'DDE' #'App'

#'Debugger' #'App'

#'Deimos' #'App'

#'DeltaStreams' #'Tools'

#'DependencyAnalyzer' #'App'

#'DGV' #'App'

#'DGVwxUI' #'App'

#'DiagramBrowser' #'App'

#'DiffMerge' #'App'

#'Diffusr' #'App'

#'DigitalSignatures' #'App'

#'Diplomatik' #'App'

#'DockingBar' #'App'

#'DomView' #'App'

#'DotNetBridge' #'App'

#'DPON' #'App'

#'DPPServices' #'App'

#'DreamLines' #'App'

#'DrGeoII' #'App'

#'DSMCore' #'App'

#'DynaGraph' #'App'

#'DynamicAspects' #'App'

#'DynamicComponents' #'LangExt'

#'DynamicProtocols' #'Tools'

#'E' #'App'

#'EasyMorphicGUI' #'App'

#'EBot' #'App'

#'Ecco' #'App'

#'ECompletion' #'Tools'

#'Ecotalk' #'App'

#'EditSourceColors' #'App'

#'EEG' #'App'

#'Eg' #'LangExt'

#'Elefante' #'App'

#'EOGlorp' #'App'

#'EtoyMaker' #'App'

#'EToysLoader' #'App'

#'EToysTests' #'Tests'

#'Exceptions' #'LangExt'

#'Exceptions.test' #'Tests'

#'ExperimentTypes' #'LangExt'

#'Explorer' #'Tools'

#'Exupery' #'App'

#'Faces' #'App'

#'Fame' #'App'

#'FameUtil' #'App'

#'Famix' #'App'

#'FAMIX2' #'App'

#'FaseDois.6' #'App'

#'FastCGI' #'App'

#'FastSets' #'App'

#'Faure' #'App'

#'FCAImporter' #'App'

#'FeatureBrowser' #'Tools'

#'Feelit' #'App'

#'FelTimetable' #'App'

#'Ferrocarril' #'App'

#'FFI' #'System'

#'File' #'App'

#'FileContentsBrowser' #'App'

#'FileList' #'App'

#'FileMan' #'App'

#'Files' #'App'

#'Filesystem' #'App'

#'Flash' #'App'

#'FlippingBook' #'App'

#'Flotr' #'App'

#'FlyingObjects' #'LangExt'

#'FlyingObjectsUI' #'LangExt'

#'FMA' #'App'

#'Fonts' #'App'

#'FormalConceptAnalysis' #'App'

#'Formation' #'App'

#'Fractal' #'App'

#'FracTalk' #'App'

#'FreeRM' #'App'

#'FreeType' #'App'

#'Freetype' #'App'

#'FrobS' #'App'

#'FRP' #'App'

#'FTP' #'App'

#'Functions' #'App'

#'Gainer' #'App'

#'Games' #'App'

#'GdsCompiler' #'App'

#'GdsFeel' #'App'

#'GeKon' #'App'

#'GemStone' #'App'

#'General' #'App'

#'Genetic' #'App'

#'Genie' #'App'

#'Geppetto' #'LangExt'

#'Geppetto2' #'LangExt'

#'GestionAlumnos' #'App'

#'GestionImmo' #'App'

#'GigsManager' #'App'

#'Giuseppe' #'App'

#'Glamour' #'App'

#'GLMorphic' #'App'

#'Glorp' #'App'

#'GlorpSeaside' #'App'

#'GlorpTest' #'App'

#'Gofer' #'App'

#'Goodies' #'App'

#'GOODS' #'App'

#'GoodsServer' #'App'

#'GoogleChart' #'App'

#'GoogleStaticMap' #'App'

#'Gradebook' #'App'

#'Graph' #'App'

#'Graphics' #'App'

#'GraphicsFiles' #'App'

#'GraphicsTests' #'Tests'

#'GraphViz' #'App'

#'Grease' #'App'

#'Green' #'App'

#'GStreamer' #'App'

#'GTD' #'App'

#'Gtk' #'App'

#'GuidedLayout' #'App'

#'Gutenberg' #'App'

#'HandySimulator' #'App'

#'Hapax' #'App'

#'HapaxMatrix' #'App'

#'Hashtable' #'App'

#'HedgeHacks' #'App'

#'HelmholtzKarlsruhe' #'App'

#'Hermes' #'App'

#'Hermion' #'Tools'

#'Hessian' #'App'

#'HID' #'App'

#'HigherOrderLists' #'App'

#'Hitman' #'App'

#'HomeSecurityProject' #'App'

#'HOP' #'App'

#'HostMenus' #'App'

#'HPDF' #'App'

#'HPGL' #'App'

#'HSM' #'App'

#'HTML' #'App'

#'HTML5' #'App'

#'HTMLParser' #'App'

#'HttpSmalltalkServerPages' #'App'

#'HV' #'App'

#'HVBlog' #'App'

#'HydraVM' #'LangExt'

#'Hyper1.333' #'App'

#'HyperCardNostalgia' #'App'

#'ICal' #'App'

#'ICalSummerTalk' #'App'

#'iCMS' #'App'

#'Iliad' #'App'

#'Ilias' #'App'

#'ImageFlow' #'App'

#'ImageMap' #'App'

#'Information' #'App'

#'InputMethods' #'App'

#'InscripcionMaterias' #'App'

#'Installer' #'Tools'

#'IntelligentGames' #'App'

#'Intensional' #'App'

#'Interaction' #'App'

#'InterleavedChangeSet' #'App'

#'IOSPersistent' #'App'

#'IPCommon' #'App'

#'iPhone' #'App'

#'IPProject' #'App'

#'IRC' #'App'

#'IRCBot' #'App'

#'IRCBot3' #'App'

#'IsisFieldControllers' #'App'

#'IsisFieldControllersTests' #'App'

#'IsisFields' #'App'

#'Islands' #'App'

#'ISobot' #'App'

#'IxMatch' #'App'

#'Jabber' #'App'

#'Jacaranda' #'App'

#'Jags' #'App'

#'JamTomorrow' #'App'

#'JavaConnect' #'App'

#'JavaScript' #'App'

#'Javascript' #'App'

#'JCompiledMethods' #'LangExt'

#'JDColorPicker' #'App'

#'JdMenu' #'App'

#'Jihachol' #'App'

#'JoeTheMiner' #'App'

#'JQuery' #'App'

#'JQWidgetBox' #'App'

#'JSPrototypeWindow' #'App'

#'Juliet' #'App'

#'K8055' #'App'

#'Kabungu' #'App'

#'Kalorik' #'App'

#'Kedama' #'App'

#'Kerala' #'App'

#'Kernel' #'System'

#'Kernel.bootstrap' #'System'

#'KernelTests' #'Tests'

#'KeyBinder' #'Tools'

#'Keymapping' #'App'

#'KFImaging' #'App'

#'KFImagingNet' #'App'

#'KFMysql' #'App'

#'KidsFirst' #'App'

#'KidsFirstSDK' #'App'

#'Koala' #'App'

#'KomAjpServer' #'App'

#'KomHttpServer' #'App'

#'KomPackaging' #'App'

#'KomServices' #'App'

#'KryptOn' #'App'

#'Kuntatti' #'App'

#'KVBinding' #'App'

#'LAN' #'App'

#'LanguageEditor' #'App'

#'LanguageInfo' #'LangExt'

#'Launcher' #'System'

#'Lava' #'App'

#'Lava testing' #'App'

#'LazyRabbit' #'App'

#'LBS' #'App'

#'LCSTalk' #'App'

#'LDAP' #'App'

#'Lichtenberg' #'App'

#'LiCoR' #'App'

#'Linda' #'App'

#'LinkChecker' #'App'

#'Lisp' #'App'

#'LivePipe' #'App'

#'LiveWiki' #'App'

#'LofEQ' #'App'

#'LoFPlayer2' #'App'

#'Logging' #'App'

#'Logic' #'App'

#'LoginBeta2' #'App'

#'Lumiere' #'App'

#'lxstage' #'App'

#'Ma Armored Code' #'App'

#'Ma base additions' #'App'

#'Ma client server' #'App'

#'Ma contextual search' #'App'

#'Ma object serialization' #'App'

#'Ma object serialization tester' #'App'

#'Ma special collections' #'App'

#'Ma Squeak domain' #'App'

#'Ma Statistics' #'App'

#'Ma time objects' #'App'

#'MagicWords' #'App'

#'Magma client' #'App'

#'Magma seaside' #'App'

#'Magma seasideHelper' #'App'

#'Magma server' #'App'

#'Magma tester' #'App'

#'Magma Tools' #'App'

#'Magritte' #'App'

#'MagritteGlorp' #'App'

#'Manhattan' #'App'

#'MantisConnect' #'App'

#'MAPI' #'App'

#'Mars' #'App'

#'MarsPlugin' #'App'

#'Marvin' #'App'

#'Math' #'App'

#'Maui' #'App'

#'MC2' #'Tools'

#'MCConflictless' #'App'

#'MD2' #'App'

#'MediaPlayers' #'App'

#'MediaView' #'App'

#'Memcached' #'App'

#'Memory' #'App'

#'MenuUI' #'App'

#'Merchant' #'App'

#'Merlin' #'App'

#'MessageCapture' #'App'

#'Metaboard' #'App'

#'MetaclassTalk' #'LangExt'

#'MetaSource' #'App'

#'Metaspin' #'App'

#'MethodAuthorship' #'App'

#'MethodWrappers3.9' #'App'

#'Mewa.Seaside2.5' #'App'

#'Milestone4' #'App'

#'Milestone5' #'App'

#'MinimalMorphic' #'Tools'

#'MinimalMorphicInitialization' #'App'

#'MinimalMorphicLoader' #'Tools'

#'MiniMorphicWrapper' #'Tools'

#'MinorityReport' #'App'

#'Miro' #'App'

#'MiroNG' #'App'

#'ML' #'App'

#'Mocketry' #'App'

#'MocketryTests' #'App'

#'modbus' #'App'

#'ModuleAlgebra' #'App'

#'Mold' #'App'

#'Momo' #'App'

#'Mondrian' #'App'

#'Monticello' #'Tools'

#'Monticello.test' #'Tests'

#'Monticello2' #'Tools'

#'Monticello2OB' #'App'

#'MonticelloConfigurations' #'App'

#'MonticelloGUI' #'Tools'

#'MonticelloTests' #'Tests'

#'Moose' #'App'

#'MooseDen' #'App'

#'MooseKGB' #'App'

#'MooseLoader' #'App'

#'Moqam' #'App'

#'MorphExamplesAndDemos' #'App'

#'Morphic' #'Tools'

#'MorphicAtInternet' #'App'

#'MorphicBooks' #'App'

#'MorphicCore' #'Tools'

#'MorphicExt' #'Tools'

#'MorphicExtras' #'Tools'

#'MorphicGames' #'App'

#'MorphicPuzzle' #'App'

#'MorphicToolsSupport' #'Tools'

#'MorphicWidgets' #'Tools'

#'MorphicWrappers' #'Tools'

#'MotionCapture' #'App'

#'Movies' #'App'

#'MoViz' #'App'

#'MPD' #'App'

#'MPKSimulation' #'App'

#'MS2' #'App'

#'MSE' #'App'

#'Mse' #'App'

#'MudPie' #'App'

#'MultiColumn Lists' #'App'

#'Multilingual' #'App'

#'Musinum' #'App'

#'MutationTesting' #'App'

#'MyMatrix' #'App'

#'Mysql' #'App'

#'NAGS' #'App'

#'Names' #'App'

#'Namespace' #'LangExt'

#'Namespaces' #'LangExt'

#'NamespaceTools' #'LangExt'

#'Nanola' #'App'

#'NARS' #'App'

#'Nebraska' #'App'

#'Net' #'App'

#'Network' #'System'

#'NetworkTests' #'Tests'

#'NewCompiler' #'System'

#'NewParser' #'System'

#'newToDo' #'App'

#'NikoBoxes' #'LangExt'

#'Nile' #'App'

#'NileBackwardCompatibility' #'App'

#'NineMensMorris' #'App'

#'Nisshoku' #'App'

#'Nodes' #'App'

#'Nodes2' #'App'

#'NsTileGame' #'App'

#'Numerics' #'App'

#'Nurikabe' #'App'

#'O2' #'Tools'

#'OAI' #'App'

#'OB' #'Tools'

#'OBChangesBrowser' #'Tools'

#'OBDependencyWalker' #'App'

#'ObjectFinder' #'App'

#'ObjectFlow' #'LangExt'

#'ObjectiveC' #'LangExt'

#'ObjectSocket' #'App'

#'ObjectVisualizer' #'App'

#'OBLightweightClass' #'Tools'

#'OBMultiSel' #'Tools'

#'OBPSemestralka' #'App'

#'OBTesting' #'Tests'

#'OBUniverse' #'App'

#'Ocompletion' #'Tools'

#'ODBC' #'App'

#'ODE' #'App'

#'Officious' #'App'

#'OFX' #'App'

#'OLE' #'App'

#'OLPC' #'App'

#'OmniBase' #'App'

#'OmniBrowser' #'Tools'

#'OmniBrowser2' #'Tools'

#'OmniSupport' #'Tools'

#'OmniTesting' #'Tests'

#'OmniTesting2' #'Tests'

#'OpenAL' #'App'

#'OpenDBX' #'App'

#'OpenDocument' #'App'

#'OpenFlashChart' #'App'

#'OpenGL' #'App'

#'OpenID' #'App'

#'OpenPGP' #'App'

#'OpenSkills1.333' #'App'

#'OpenVG' #'App'

#'OPMLParser' #'App'

#'OracleProcedureUtilities' #'App'

#'Orion' #'App'

#'OrionDevelopment' #'App'

#'OrionTest' #'Tests'

#'OSProcess.4.3' #'System'

#'OSProcess.filelockcache' #'System'

#'OSSB' #'App'

#'Othello' #'App'

#'Package' #'LangExt'

#'PackageInfo' #'System'

#'Packages' #'System'

#'PacketStudio' #'App'

#'PagedReader' #'App'

#'Paragraph' #'App'

#'Passport' #'App'

#'Pattern' #'App'

#'PBE' #'App'

#'PBObjects' #'App'

#'PDAMorph' #'App'

#'PECOS' #'App'

#'PEGSQLParser' #'App'

#'Persephone' #'LangExt'

#'Perseus' #'App'

#'PetitCoral' #'App'

#'PharoExamples' #'App'

#'PhotoBlog' #'App'

#'PhotoPublisher' #'App'

#'PhT' #'App'

#'PhysicalEtoys' #'App'

#'Pica' #'App'

#'PicoWiki' #'App'

#'PicWorks' #'App'

#'Pier' #'App'

#'PierImport' #'App'

#'PierPersistentStore' #'App'

#'Pitch Set' #'App'

#'Plasencia' #'App'

#'Platypus' #'App'

#'PlayerST' #'App'

#'PlbStateReplicationProtocol' #'App'

#'PLoP' #'App'

#'Plot' #'App'

#'PlotKit' #'App'

#'PlotKitLibrary' #'App'

#'Plotr' #'App'

#'PlusTools' #'App'

#'PolicyTools' #'App'

#'Polymorph' #'Tools'

#'PostgresV2' #'App'

#'PreferenceBrowser' #'Tools'

#'Prevayler' #'App'

#'ProcessBrowser' #'App'

#'Processing' #'App'

#'ProcessModel' #'App'

#'ProcessWrapper' #'App'

#'Prolog' #'LangExt'

#'Promoter' #'App'

#'Protocols' #'System'

#'protoGrowl' #'App'

#'Prototype' #'LangExt'

#'PVpub' #'App'

#'Q2v0.4' #'App'

#'Qifer' #'App'

#'Quote' #'App'

#'RandomLoops' #'App'

#'Raphael' #'App'

#'RAR Milestone 3' #'App'

#'Raytracer' #'App'

#'RayTracing' #'App'

#'ReacTalk' #'LangExt'

#'Real Time Group Editor' #'App'

#'Realtalk' #'LangExt'

#'Reef' #'App'

#'Refactoring' #'Tools'

#'RefactoringEngine' #'Tools'

#'Refactory' #'Tools'

#'Regex' #'App'

#'ReleaseBuilder' #'App'

#'RemoteObjects' #'App'

#'RenderMouse' #'App'

#'REPL' #'App'

#'REPLMorph' #'App'

#'REServe' #'App'

#'Reversi' #'App'

#'RFB' #'App'

#'RFStreams' #'App'

#'Rio' #'App'

#'RiskMetrics' #'App'

#'Rmt' #'App'

#'RO' #'App'

#'Roboquad' #'App'

#'RoboRally' #'App'

#'RoboSapien' #'App'

#'RobotSoccer' #'App'

#'Roe' #'App'

#'RoelTyper' #'Tools'

#'Rome' #'App'

#'RPackage' #'LangExt'

#'RPGFlyn' #'App'

#'RSRSS' #'App'

#'RSRSS2' #'App'

#'RSS' #'App'

#'rST' #'LangExt'

#'rSTAdd' #'LangExt'

#'Rtoys' #'App'

#'RWS' #'App'

#'SAB' #'App'

#'Safara' #'App'

#'Sake' #'App'

#'Sandcastle' #'App'

#'Sandstone' #'App'

#'SandstoneDb' #'App'

#'Saphir' #'App'

#'SARInstaller' #'App'

#'SAweb' #'App'

#'SAZIPortal' #'App'

#'Scamper' #'App'

#'Scl' #'App'

#'Scouts' #'App'

#'Scrabble' #'App'

#'Scribo1.0' #'App'

#'Scriptaculous' #'App'

#'ScriptaculousAddOns' #'App'

#'Scripter' #'App'

#'ScriptLoader' #'System'

#'ScriptLoader11' #'Tools'

#'ScriptManager' #'Tools'

#'SDTS' #'App'

#'SeaBreeze' #'App'

#'SeaChart' #'App'

#'SeaChartDemo' #'App'

#'Seaside' #'App'

#'Seaside RSS' #'App'

#'Seaside2' #'App'

#'Seaside28Jetsam' #'App'

#'SeasideAssistants' #'App'

#'SeasideAsync' #'App'

#'SeasideDynamicSVG' #'App'

#'SeasideFAQ' #'App'

#'SeasideMooTools' #'App'

#'SeasideTesting' #'Tests'

#'SeasideXUL' #'App'

#'SEATools' #'App'

#'SEBeatsweb' #'App'

#'SEBeatwebs' #'App'

#'SelectorNamespace' #'LangExt'

#'Semestral' #'App'

#'Sentorsa' #'App'

#'SentorsaSeaside' #'App'

#'SentorsaSeasideForms' #'App'

#'Services' #'Tools'

#'Sextant' #'App'

#'SGrid' #'App'

#'Shapes' #'App'

#'SharedStreams' #'App'

#'ShoreBaseModel' #'App'

#'ShoreComponents' #'App'

#'ShoreComponentsExperimental' #'App'

#'Shout' #'Tools'

#'ShoutCore' #'Tools'

#'Shp' #'App'

#'SimpleCoverage' #'App'

#'SimpleLog' #'App'

#'SIXX' #'App'

#'Skins' #'App'

#'SlideShare' #'App'

#'Slime' #'App'

#'SmaCC' #'App'

#'SmaCCDev' #'App'

#'Smallab' #'App'

#'Smallapack' #'App'

#'SmallBlog' #'App'

#'SmallBrother' #'Tools'

#'Smallchange' #'App'

#'SmallComponents' #'App'

#'SmallDude' #'App'

#'SmallFaces' #'App'

#'SmallFacesExamples' #'App'

#'SmallLang' #'App'

#'SmallScheme' #'App'

#'SmallScript' #'LangExt'

#'Smalltalk2Java' #'App'

#'SmalltalkAMF' #'App'

#'SmalltalkP' #'App'

#'SmallWiki' #'App'

#'SmallWiki2' #'App'

#'SMBase' #'App'

#'SMIME' #'App'

#'SMLoader' #'App'

#'SMock' #'App'

#'SMTP' #'App'

#'Snmp' #'App'

#'SOAP' #'App'

#'SocRecording' #'App'

#'SOI' #'App'

#'SOIDavos' #'App'

#'Sonora' #'App'

#'Sophie' #'App'

#'SOUL' #'LangExt'

#'Soul' #'LangExt'

#'Sound' #'App'

#'SoundMorphicUserInterface' #'App'

#'SoundsLike' #'App'

#'Soup' #'App'

#'Sourcetalk' #'App'

#'Space' #'App'

#'SpaceWar' #'App'

#'SPDF' #'App'

#'Speech' #'App'

#'Spielverderber' #'App'

#'Sport' #'App'

#'Spy' #'App'

#'SpyBrowser' #'Tools'

#'SpyCam' #'App'

#'SpyWare' #'Tools'

#'SqPlatypus' #'App'

#'Squeak People' #'App'

#'SqueakBot' #'App'

#'SqueakCell' #'App'

#'SqueakDefense' #'App'

#'SqueakElib' #'App'

#'SqueakElibCompiler' #'App'

#'SqueakElibVM' #'App'

#'SQueaken' #'App'

#'SqueakEnh' #'App'

#'SQueakenUI' #'App'

#'SqueakNOS' #'LangExt'

#'SqueakNxt' #'App'

#'SqueakPeopleStats' #'App'

#'SqueakPipe' #'App'

#'SqueakPoker' #'App'

#'SqueakPokerTest' #'Tests'

#'SqueakSet' #'App'

#'SqueakSource' #'App'

#'SqueakSource2' #'App'

#'SqueakTypes' #'LangExt'

#'Squill' #'App'

#'SRP' #'App'

#'SSH' #'App'

#'SSL' #'App'

#'SSpec' #'App'

#'SSpec Tests' #'Tests'

#'ST2JS' #'App'

#'ST80' #'System'

#'Stamp' #'App'

#'StarBrowser' #'Tools'

#'StarSqueak' #'LangExt'

#'StaticCoverageTool' #'App'

#'Stellar' #'App'

#'Stemmer' #'App'

#'StepWorks' #'App'

#'STicky' #'App'

#'StMud' #'App'

#'Store' #'App'

#'StoryEvaluator' #'App'

#'STTutTodoApp' #'App'

#'Subjectivity' #'LangExt'

#'SUExtensions' #'App'

#'SummerTime' #'App'

#'SUnit' #'App'

#'SUnitGUI' #'App'

#'SunnysidePlanning' #'App'

#'SunnysidePlanning2' #'App'

#'SVG' #'App'

#'SVI' #'App'

#'SW2Calendar' #'App'

#'SwaLint' #'App'

#'Swazoo' #'App'

#'SWFObject' #'App'

#'SWHTTPClient' #'App'

#'SWPrivacy' #'App'

#'SWT' #'App'

#'Synchronization' #'LangExt'

#'System' #'System'

#'System.test' #'Tests'

#'SystemChangeNotification' #'System'

#'SystemEditor' #'System'

#'Table' #'App'

#'Tables' #'App'

#'TableTests' #'App'

#'TalkBack' #'App'

#'Tamaris' #'App'

#'TamarisAddons' #'App'

#'TDD' #'App'

#'TeamCreation' #'App'

#'TeaShop' #'App'

#'Techo' #'App'

#'TeePuzzle' #'App'

#'TerrainBuilder' #'App'

#'TestBrowser' #'Tools'

#'Testing' #'Tests'

#'Testing Tests' #'Tests'

#'TestLint' #'Tests'

#'Tests' #'Tests'

#'TestServer' #'App'

#'TestSmells' #'App'

#'TestsMonticello' #'Tests'

#'ThingLab' #'App'

#'Time' #'App'

#'TinyWiki' #'App'

#'Tirade' #'App'

#'ToDo' #'App'

#'ToolBuilder' #'Tools'

#'ToolDad' #'App'

#'Tools' #'System'

#'Tooltip' #'App'

#'Toothpick' #'App'

#'Topologos' #'App'

#'TraceLibrary' #'App'

#'Tracing Messages Browser' #'Tools'

#'Traits' #'LangExt'

#'Traits.test' #'Tests'

#'TraitsExamples' #'LangExt'

#'TraitsModel' #'App'

#'TraitsMonticello.flattened' #'LangExt'

#'TraitsOmniBrowser' #'Tools'

#'TraitsOmniBrowserTests' #'Tests'

#'TraitsUI' #'LangExt'

#'TreeMerge' #'App'

#'Trees' #'App'

#'Tric' #'App'

#'Trike' #'App'

#'TrueType' #'App'

#'Trx' #'App'

#'TTFSupport' #'App'

#'TTPrototip' #'App'

#'Tuio' #'App'

#'TuringMachine2' #'App'

#'Tutorial' #'App'

#'TypePlug' #'LangExt'

#'TypePlugBrowser' #'LangExt'

#'TypeSystem' #'LangExt'

#'TypeSystemEngine' #'LangExt'

#'TypeSystemParser' #'LangExt'

#'TypeSystemVisualizer' #'App'

#'UB' #'App'

#'UbiquiTalk' #'Tools'

#'Unibe' #'App'

#'Universes' #'App'

#'Unlur' #'App'

#'Unnamed' #'App'

#'Unstuck' #'Tools'

#'Utilities' #'App'

#'UTSampleClient' #'App'

#'VacationTracking' #'App'

#'VB' #'App'

#'VB6' #'App'

#'Veeracom' #'App'

#'VerletParticles' #'App'

#'VersionNumber' #'System'

#'VHRP' #'App'

#'VideoForSqueak' #'App'

#'ViewPoints' #'App'

#'VirtualMuseum' #'App'

#'VMConstruction' #'App'

#'VMMaker' #'System'

#'Voronoi' #'App'

#'VWXML' #'App'

#'WaterOuzel' #'App'

#'WAX' #'App'

#'WebForum' #'App'

#'WebScrabble' #'App'

#'WebStore' #'App'

#'WebStoreTests' #'App'

#'WebTester' #'App'

#'Whiteboard' #'App'

#'WifiBot' #'App'

#'Wiimote' #'App'

#'WikiPhone' #'App'

#'WikiTracker' #'App'

#'WireSqueak' #'App'

#'Wisconsin' #'App'

#'WizardSystem' #'App'

#'WoG' #'App'

#'Wom' #'App'

#'WorryWart' #'App'

#'WriteBarrier' #'App'

#'WxTools' #'App'

#'WxWidgets' #'App'

#'WYSIWYG' #'App'

#'X36OBP' #'App'

#'XBase' #'App'

#'XLAParser' #'App'

#'XML' #'App'

#'XMLPullParser' #'App'

#'XPath' #'App'

#'XSLFO' #'App'

#'xtra' #'App'

#'XTream' #'App'

#'XUL' #'App'

#'YABreakOut' #'App'

#'Yadis' #'App'

#'YAZ' #'App'

#'Z3950' #'App'

#'Z3950Servers' #'App'

#'Zafra' #'App'

#'Zurbaran' #'App'
)! !

!FSource class methodsFor: 'info-lists' stamp: 'OzC 12/14/2010 12:23'!
top15Pkgs
	^ #(
	Seaside
Morphic
Miro
Formation
System
SpyWare
OB
Network
Chuck
MinimalMorphic
Magritte
Tests
O2
Platypus
Collections
	)! !

Object subclass: #FSourceRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FSourceRef class methodsFor: 'selectors-smalltalk' stamp: 'OzC 8/8/2011 16:51'!
smalltalkNoAliasingSelectors 
	^ #(
	#==
	#~~
	)
	
"	changeImageNameTo:
	saveAs
	saveAs:"! !

!FSourceRef class methodsFor: 'selectors-smalltalk' stamp: 'OzC 8/8/2011 16:21'!
smalltalkReadingSelectors "these methods are insufficient!!!!!!"
	^ #(
#allBehaviorsDo:
#allCallsOn2:
#allClasses
#allClassesAndTraits
#allClassesAndTraitsDo:
#allClassesAnywhereDo:
#allClassesDo:
#allClassesInCategory:do:
#allObjectsDo:
#allTraits
#associationAt:
#associationAt:ifAbsent:
#associationsDo:
#at:
#at:ifAbsent:
#at:ifPresent:
#at:ifPresentAndInMemory:
#atOrBelow:ifAbsent:

#classNamed:
#classNames
#classOrTraitNamed:

#hasClassNamed:

#includesKey:

#keyAtIdentityValue:
#keyAtIdentityValue:ifAbsent:
#keyAtValue:
#keyAtValue:ifAbsent:
#keyNotFoundError:
#keys
#keysAndValuesDo:
#keysDo:
	)
	"Discarded:

#asString
#askForBrowsingMethodsWithSourceString
#beep
#beepPrimitive
#browseAllObjectReferencesTo:except:ifNone:
#browseMessageList:name:
#bytesLeft
#bytesLeft:
#bytesLeftString

#cleanOutUndeclared
#cleanUpUndoCommands
#clearExternalObjects
#clipboardText
#clipboardText:
#compactClassesArray
#condenseChanges
#condenseSources
#confirm:
#currentHand
#currentProjectDo:
#currentWorld
#discard3D
#discardDiscards
#discardFFI
#discardFlash
#discardMIDI
#discardMorphic
#discardNetworking
#discardOddsAndEnds
#discardSUnit
#discardSoundAndSpeech
#discardSoundSynthesis
#discardSpeech
#discardTrueType
#discardWonderland

#endianness
#entryCount
#environmentForCategory:
#externalObjects
#fixObsoleteReferences
#flushClassNameCache
#forceTenure
#forgetDoIts
#fullNameForChangesNamed:
#fullNameForImageNamed:
#garbageCollect
#garbageCollectMost
#getSizeClassNamesInCategory:
#getSystemAttribute:
#handleUserInterrupt
#hasMorphic
#hasSpecialSelector:ifTrueSetByte:
#ifTrue:ifFalse:
#imageImports
#imageName
#imagePath
#imageURL
#installLowSpaceWatcher
#isBigEndian
#isLittleEndian
#isMars
#isMorphic
#isNil
#isSelfEvaluating
#isSmalltalkX
#kernelCategories
#lastQuitLogPosition
#lastUpdateString
#lenientScopeHas:ifTrue:
#listBuiltinModules
#listLoadedModules
#logChange:
#logError:inContext:to:
#lowSpaceThreshold
#lowSpaceWatcherProcess
#maAt:ifPresent:ifAbsent:
#machineType
#makeSqueaklandReleasePhaseCleanup
#makeSubEnvironmentNamed:
#memoryHogs
#mooseName
#newChanges:
#noSuchMessage
#okayToProceedEvenIfSpaceIsLow
#organization
#organizer
#osVersion
#platformName
#platformSubtype
#pointersTo:
#pointersTo:except:
#poolDictionaryAt:ifAbsent:
#presumedSentMessages
#primBytesLeft
#primaryLanguage:
#primitiveGarbageCollect
#printString
#processShutDownList:
#processStartUpList:
#product
#quitPrimitive
#reclaimDependents
#recreateSpecialObjectsArray
#registerExternalObject:
#reject:
#removeAllUnSentMessages
#removeEmptyMessageCategories

#removeNormalCruft
#respondsTo:
#rewriteIndirectRefs
#saveAsNewVersion
#saveChangesInFileNamed:
#saveImageInFileNamed:
#saveSession
#setGCBiasToGrow:
#setGCBiasToGrowGCLimit:
#setGCParameters
#setMacFileInfoOn:
#setName:inOuterEnvt:
#signalLowSpace
#size
#smartBrowseAllCallsOn:inClass:
#snapshot:andQuit:
#snapshot:andQuit:embedded:
#someObject
#specialNargsAt:
#specialObjectsArray
#specialSelectorAt:
#specialSelectorSize
#specialSelectors
#swapHalvesIn:from:to:
#systemInformationString
#systemLanguage
#systemLanguage:
#systemNavigation
#timeStamp:
#traitNames
#unloadModule:
#unregisterExternalObject:
#unusedClasses
#unusedClassesAndMethodsWithout:
#values
#verifyMorphicAvailability
#version
#versionName
#vmDebugOff
#vmDebugOn
#vmParameterAt:
#vmParameterAt:put:
#vmVersion
#windowSystemName
#wordSize
#writeRecentCharacters:toFileNamed:
#writeRecentToFile
#zapAllOtherProjects
	
	"! !

!FSourceRef class methodsFor: 'selectors-smalltalk' stamp: 'OzC 8/8/2011 16:45'!
smalltalkSuspectReadingSelectors 
"	 #(
#abandonTempNames
#addToShutDownList:
#addToShutDownList:after:
#addToStartUpList:
#addToStartUpList:after:

#allImplementorsOf2: ?
#allImplementorsOf: ?
#allSelect: ?
#asArray ?
#bindingOf: ?
#changes
#changesName
#class 
#classes ?
#declare:from: ? 
#defineClass:superclass:indexedType:private:instanceVariableNames:classInstanceVariableNames:imports:category: ?
#defineNameSpace:private:imports:category: ?
#defineNamespace: ?
#do: ?
#inspectGlobals
#obsoleteBehaviors
#obsoleteClasses
#removeFromShutDownList:
#removeFromStartUpList:
#yourself
)

"! !

!FSourceRef class methodsFor: 'selectors-smalltalk' stamp: 'OzC 8/8/2011 16:22'!
smalltalkWritingSelectors 
	^ #(
	#at:put:
	#at:ifAbsentPut:
	#forgetClass:logged: 
	#removeKey:
	#removeKey:ifAbsent:
	#removeSelector:
	#renameClass:as:
	
	#add:
	#removeClassNamed:
	#renameClassNamed:as:
	)
	
"	changeImageNameTo:
	saveAs
	saveAs:"! !

Object subclass: #FTop
	instanceVariableNames: 'selectors refs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FEaturesFInder-Core'!

!FTop class methodsFor: 'as yet unclassified' stamp: 'OzC 11/10/2010 21:36'!
fromEcoSystem: ecco load: selectors and: ids
	|dicts|
	dicts := ecco allSndImplofs: selectors  andRefs: ids.
	^ FTop new loadSnds: (dicts at: 1) impls: (dicts at: 2) refs: (dicts at:3)! !

!FTop class methodsFor: 'as yet unclassified' stamp: 'OzC 1/17/2011 15:12'!
loadAllFromEcoSystem: eco
	|sources|
	sources :=  FSource class allSelectorsInCategory: 'selectors'.
	
	^ self fromEcoSystem: eco load: (sources inject: OrderedCollection new into: [ :ls :src | ls addAll: (FSource perform: src) . ls]) and: {"#Smalltalk"} ! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/27/2011 18:48'!
allDangerousMethodNames
	 ^ selectors inject: Set new into: [:s :fs | 
		s addAll: (fs allDangerousSenders collect: #asString) . 
		s]! !

!FTop methodsFor: 'accessing' stamp: 'OzC 10/15/2010 23:58'!
allImplementors 
	^ selectors inject: OrderedCollection new into: [:ls :fs | ls addAll: fs allImplementors . ls] ! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/5/2011 14:05'!
allMethodNames
	 ^ selectors inject: Set new into: [:s :fs | 
		s addAll: (fs fdata collect: #asString) . 
		s]! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 8/8/2011 22:58'!
allPkgCtg
	|  bodyDict|
	
		bodyDict := Dictionary newFrom: (FSource pkgCategories collect: [:ctg | ctg -> 0]).	
		self refs"selectors" do: [ :fs | fs fdata do: [:fd | fd countOnPkgCtg: bodyDict]].
		^ bodyDict . 			
		! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/5/2011 15:17'!
allProjectNames
	|names|
	names := OrderedCollection new.
	selectors do: [:fs | 
		fs fdata do: [:fd| |pkgName|
			pkgName := fd senderProjectName. 
			(names includes: pkgName) ifFalse: [names add: pkgName]]] displayingProgress: 'generating names'.
	^ names ! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/14/2011 18:59'!
allProjectsByCtg
	|dict|
	dict := Dictionary newFrom: (FSource pkgCategories collect: [:c | c -> false]).
	dict keysDo: [:k |
		dict at: k put: ((self selectPkgCategory: k) selectors at: 1) allProjectNames
		].
	^ dict ! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/5/2011 15:17'!
allRefsOfPkg: shortPkgName
	^ selectors inject: OrderedCollection new into: [:os :fs |
		fs fdata do: [:fd |
			fd senderProjectName = shortPkgName ifTrue:[
				os add: fd]].
		os] ! !

!FTop methodsFor: 'accessing' stamp: 'OzC 8/8/2011 23:10'!
allSenders
	|snds|
	snds := OrderedCollection new.
	"selectors"refs do: [:fs | snds addAll: fs fdata] displayingProgress: 'merging all sender refs'.
	^ snds! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/14/2011 18:19'!
allSendersInCtg: ctgName
	^ self allSenders select: [:fd | |pkgName ctg|
			pkgName := fd senderProjectName. 
			ctg := FSource cachedPkgCtg at:  fd senderProjectName  ifAbsent: [ctg:= #dummy] . 
			ctgName = #Tests ifTrue: [ ctg = ctgName or: [fd isTestCase]] 
				ifFalse: [ctg = ctgName and: [fd isTestCase not]]] "TODO: it need to change later"! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 11/25/2010 17:52'!
asArry: aDict withColNamed: name "Symbol"
	|flat flag|
	flat := OrderedCollection new.
	flag := true.
	aDict keysAndValuesDo: [:ctg :dict | |row|
		flag ifTrue: [ flat add: {name} , (dict keys) . flag:=false].
		row:= (flat at: 1) veryDeepCopy .
		row at: 1 put: ctg.
		dict keysAndValuesDo: [:k :v | row at: (row indexOf: k) put: v].
		flat add: row].
	^ flat	

	
	
		
	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 1/14/2011 11:25'!
collectFlatPkgCtgData
	^(Matrix newFromArrays: 
		 (self asArry: self collectPkgCtgData withColNamed: #features)) asArrays 	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 11/26/2010 14:54'!
collectFlatReceiverData
	^(Matrix newFromTransposedArrays: 
		 (self asArry: self collectReceiverData withColNamed: #categories)) asArrays 	

	
	
		
	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 12/6/2010 10:33'!
collectFlatReceiverDataWithTests
	^(Matrix newFromTransposedArrays: 
		 (self asArry: self collectReceiverDataWithTests withColNamed: #categories)) asArrays 	

	
	
		
	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 11/29/2010 19:48'!
collectFlatReferenceData
	^(Matrix newFromTransposedArrays: 
		 (self asArry: (refs at: 1) collectReferenceData withColNamed: #categories)) asArrays 	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 12/7/2010 10:36'!
collectFlatReferenceDataWithTests
	^(Matrix newFromTransposedArrays: 
		 (self asArry: (refs at: 1) collectReferenceDataWithTests withColNamed: #categories)) asArrays 	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 11/25/2010 17:53'!
collectFlatSenderData
	^ self asArry: self collectSenderData withColNamed: #projects	

	
	
		
	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 1/14/2011 10:56'!
collectPkgCtgData 
	|sources ctgs dict|
	sources :=  FSource class allSelectorsInCategory: 'selectors' "#(#objectFieldUpdatingSelectors #objectUpdatingSelectors)".
	ctgs := #(#LangExt #Tools #App #System #Tests).
	dict := Dictionary new.
	
	sources do: [:source | |ftop bodyDict |
		ftop:= self selectThese: (FSource perform: source).
		bodyDict := Dictionary newFrom: (ctgs collect: [:ctg | ctg -> 0]).	
		ftop selectors do: [ :fs | fs fdata do: [:fd | fd countOnPkgCtg: bodyDict]].
		dict at: source put: bodyDict . 			
		] displayingProgress: 'Collecting pkg ctg'.
	
	^ dict
	
! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 11/25/2010 16:30'!
collectReceiverData
	|dict body|
	dict := Dictionary new.
	body := {#ttotal . #ttests} , (self allProjectNames).
	#(#varname #self #clsname #stexpr) 
		do: [:key | dict at: key put: (Dictionary newFrom: (body veryDeepCopy collect: [:k| k->0]))].
	selectors do: [:fs |fs collectReceiverDataOn: dict] "displayingProgress: 'collecting receiver data'".
	^ dict 
	
	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 12/7/2010 10:44'!
collectReceiverDataWithTests
	|dict body|
	dict := Dictionary new.
	body := {#ttotal . #ttests} , (self allProjectNames).
	#(#varname #'varname-tests' #self #'self-tests' #clsname #'clsname-tests' #stexpr #'stexpr-tests') 
		do: [:key | dict at: key put: (Dictionary newFrom: (body veryDeepCopy collect: [:k| k->0]))].
	selectors do: [:fs |fs collectData: fs receivers withTestsOn: dict] "displayingProgress: 'collecting receiver data'".
	^ dict 
	
	! !

!FTop methodsFor: 'collecting-data' stamp: 'OzC 11/25/2010 16:42'!
collectSenderData
	|dict body|
	dict := Dictionary new.
	body := {#ttotal . #ttests} .
	(self allProjectNames)
		do: [:key | dict at: key put: (Dictionary newFrom: (body veryDeepCopy collect: [:k| k->0]))].
	selectors do: [:fs |fs collectSenderDataOn: dict] "displayingProgress: 'collecting receiver data'".
	^ dict 	! !

!FTop methodsFor: 'collecting-data-util' stamp: 'OzC 1/17/2011 20:06'!
dangerousProjectsByCtg 
 |dict|
	dict := Dictionary newFrom: (FSource pkgCategories collect: [:c | c -> false]).
	dict keysDo: [:k |
		dict at: k put: ((self selectPkgCategory: k) selectors at: 1) allDangerousProjectNames
		].
	^ dict ! !

!FTop methodsFor: 'initialization' stamp: 'OzC 11/15/2010 15:18'!
initialize 
	selectors := SortedCollection new.
	refs := SortedCollection new.! !

!FTop methodsFor: 'loading-data' stamp: 'OzC 11/25/2010 21:29'!
loadSnds: sdict impls: idict refs: vdict
	sdict keysAndValuesDo: [:selector :ls | |fs|
		fs := FSelector new fname: selector. 
		fs loadSenders: ls.
		(idict includesKey: selector) ifTrue:[ 
			fs loadImplementors: (idict at: selector).
			idict removeKey: selector].
		selectors add: fs].
	idict keysAndValuesDo: [:selector :ls | selectors add: (FSelector new fname: selector ; loadImplementors: ls)].
	
	vdict keysAndValuesDo: [:ref :ls |refs add: (RefCategory new fname: ref ; loadRefs: ls)]! !

!FTop methodsFor: 'printing' stamp: 'OzC 11/25/2010 18:19'!
printOn: aStream
	"FF[n selectors, m senders, l implementors]"
	aStream nextPutAll: 'FT[' ; print: selectors size ; nextPutAll:'selectors, '
							 ; print: self allSenders size ; nextPutAll: 'senders, ' 
							 ; print: self allImplementors size ; nextPutAll: 'implementors]'! !

!FTop methodsFor: 'accessing' stamp: 'OzC 8/8/2011 13:11'!
refs 
	^ refs 
	! !

!FTop methodsFor: 'split' stamp: 'OzC 8/19/2011 12:29'!
selectAllWithFilter
	^ self selectTheseWithFilter: FSource allInOne ! !

!FTop methodsFor: 'split' stamp: 'OzC 1/14/2011 18:13'!
selectPkgCategory: name
	|ftop fs|
	ftop := self class new.
	fs := FSelector new fname: 'all'. 
	fs loadSenders: (self allSendersInCtg: name).
	ftop selectors add: fs.
	^ ftop! !

!FTop methodsFor: 'split' stamp: 'OzC 1/14/2011 18:13'!
selectProjectName: name
	|ftop fs|
	ftop := self class new.
	fs := FSelector new fname: 'all'. 
	fs loadSenders: (self allRefsOfPkg: name).
	ftop selectors add: fs.
	^ ftop! !

!FTop methodsFor: 'split' stamp: 'OzC 8/8/2011 22:43'!
selectRefs: ctg
	|ftop|
	ftop := self class new.
	refs do: [ :ref| |rf|
		rf := RefCategory new fname: ref fname .
		rf loadRefs: (ref refs at: ctg) fdata.
		ftop refs add: rf.
		].
	^ ftop! !

!FTop methodsFor: 'split' stamp: 'OzC 8/8/2011 13:14'!
selectRefsWithFilter
	|ftop|
	ftop := self class new.
	refs do: [ :ref| |rf|
		rf := RefCategory new fname: ref fname .
		rf loadRefs: (ref fdata select: #isInTop1000).
		ftop refs add: rf.
		].
	^ ftop! !

!FTop methodsFor: 'split' stamp: 'OzC 11/26/2010 12:14'!
selectThese: ls
	|ftop|
	ftop := self class new.
	selectors do: [:fs | (ls includes: fs fname) ifTrue: [ ftop selectors add: fs] ].
	^ ftop! !

!FTop methodsFor: 'split' stamp: 'OzC 8/19/2011 12:31'!
selectTheseWithFilter: ls
	|ftop fs|
	ftop := self class new.
	fs := FSelector new fname: 'all'. 
	selectors do: [:f | (ls includes: f fname) ifTrue: [ 
			fs loadSenders: (f fdata select: #isInTop1000 )] ]
			displayingProgress: 'Collecting selectors'.
	ftop selectors add: fs.
	^ ftop! !

!FTop methodsFor: 'accessing' stamp: 'OzC 11/26/2010 11:51'!
selectors 
	^ selectors 
	! !

!FTop methodsFor: 'printing' stamp: 'OzC 12/6/2010 13:39'!
writeData: prefix 
	|sources|
	sources :=  FSource class allSelectorsInCategory: 'selectors' "#(#objectFieldUpdatingSelectors #objectUpdatingSelectors)".
	
	self writeItSelf: prefix .
	
	sources do: [:source | |ftop|
		ftop:= self selectThese: (FSource perform: source).
		FileStream writeAsCsv: (ftop collectFlatReceiverDataWithTests) 
				     on: ('csvs/', prefix ,'-' ,(source copyFrom: 1 to: (source indexOf: $S) - 1), '-rtv.csv').  
		FileStream writeAsCsv: (ftop collectFlatSenderData) 
				     on: ('csvs/', prefix ,'-' ,(source copyFrom: 1 to: (source indexOf: $S) - 1), '-sv.csv').  		
		] displayingProgress: 'Selecting & printing'! !

!FTop methodsFor: 'printing' stamp: 'OzC 12/6/2010 15:07'!
writeItSelf: prefix 
		FileStream writeAsCsv: (self collectFlatReceiverDataWithTests) 
				     on: ('csvs/', prefix , '-in-one-rtv.csv').  
		FileStream writeAsCsv: (self collectFlatSenderData) 
				     on: ('csvs/', prefix, '-in-one-sv.csv').  		! !

!FTop methodsFor: 'printing' stamp: 'OzC 12/10/2010 17:23'!
writeRefs: prefix
	FileStream writeAsCsv: (self collectFlatReferenceDataWithTests) on: 'csvs/', prefix , '-SmalltalkRefs-rfv.csv' ! !

!Object methodsFor: '*featuresfinder' stamp: 'OzC 10/15/2010 23:46'!
isNotTrait
	^ self isTrait not! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/2/2010 22:53'!
allImplementorsOn: dict
	snapshot definitions do: [:def | 
		(def isMethodDefinition and: [dict includesKey: def selector] ) ifTrue:[ 
				(dict at: def selector) add: ((def as: FMthDef) mcVersion: self)]]
! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/10/2010 13:09'!
allReferencesOn: dict
	snapshot definitions do: [:def | 
		def isMethodDefinition ifTrue:[ 
			(FIdentifierVisitor on: dict) def: ((def as: FMthDef) mcVersion: self) 
				; visit: (FDataVisitor parseOnRB: def source)]]
			! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 8/5/2011 10:19'!
allSendersOn: dict
	snapshot definitions do: [:def | 
		def isMethodDefinition ifTrue:[ 
			(FMessageVisitor on: dict) def: ((def as: FMthDef) mcVersion: self) 
				; visit: (FDataVisitor parseOnRB: def source )]]
		displayingProgress: 'Collecting Senders'
			 ! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/10/2010 13:08'!
allSendersOn: sdict andImplementorsOn: idict
	snapshot definitions do: [:def | 
		def isMethodDefinition ifTrue:[ |ndef|
			ndef := (def as: FMthDef) mcVersion: self.
			(FMessageVisitor on: sdict) def: ndef ; visit: (FDataVisitor parseOnRB: ndef source).
			(idict includesKey: def selector ) ifTrue:[ (idict at: def selector) add: ndef ]]]
			! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/10/2010 13:07'!
allSndOn: sdict implOn: idict refOn: vdict
	snapshot definitions do: [:def | 
	def isMethodDefinition ifTrue:[ |ndef mth|
			ndef := (def as: FMthDef) mcVersion: self.
			mth := FDataVisitor parseOnRB: ndef source.
			(FMessageVisitor on: sdict) def: ndef ; visit: mth.
			(FIdentifierVisitor on: vdict) def: ndef ; visit: mth.
			(idict includesKey: def selector ) ifTrue:[ (idict at: def selector) add: ndef ]]]! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/22/2010 12:41'!
atClsDef: clsName "::Symbol"
	snapshot definitions do: [:def | 
		def isPureClsDef ifTrue: [ def className = clsName ifTrue: [^ def]]].
	^ nil
	! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 12/14/2010 13:25'!
collectNONon: ns andDITon: ds
	self snapshot definitions do: [:def |
		def isMethodDefinition ifTrue:[ ns add: def numberOfNodes ].
		def isPureClsDef ifTrue:[ds add: (def depthOfInheritanceIn: self)]]! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/16/2010 11:32'!
ditAvgMax
	|avg max n|
	n := 0. max := 0. avg:= 0.
	(snapshot definitions select: #isPureClsDef) do: [:def | |dit|
		dit := def depthOfInheritanceIn: self .
		n:= n + 1.	max:= max max: dit.	avg := avg + dit.].
	^n = 0 ifTrue: [{0 . 0}] ifFalse: [{avg / n asFloat. max}]! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 2/3/2013 23:15'!
hasTestCase
	|ccached mcached|
 	ccached := mcached := Set new.
	snapshot definitions do: [:def |
		
		(def isPureClsDef and: [(def isTestCaseIn: self )]) ifTrue: [
			(mcached includes: def className) 
				ifTrue: [ ^ true ]
				ifFalse: [ ccached add: def className.]
			].
		(def isMethodDefinition and: [def isTestMethod]) ifTrue: [
			(ccached includes: def className) 
				ifTrue: [ ^ true ]
				ifFalse: [ mcached add: def className.]
			].
		].
	^ false! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 1/12/2011 03:19'!
nolc 
	|total |
	total := 0.
	(snapshot definitions select: #isMethodDefinition) do: [:def | total:= total + def nolc].
	^ total! !

!MCVersion methodsFor: '*featuresfinder' stamp: 'OzC 11/15/2010 22:09'!
nonAvgMax 
	|max avg n|
	n := 0. max := 0. avg:= 0.
	(snapshot definitions select: #isMethodDefinition) do: [:def | |non|
		non := def numberOfNodes .
		n:= n + 1.	max:= max max: non.	avg := avg + non.].
	^n = 0 ifTrue: [{0 . 0}] ifFalse: [{avg / n asFloat. max}]! !

!ClassDescription methodsFor: '*featuresfinder' stamp: 'OzC 11/25/2010 20:05'!
allSelectorsInCategory: str
 ^ (self withAllSuperclasses 
		inject: OrderedCollection new
		into: [:selectors :class | 
				selectors
					addAll: (class organization listAtCategoryNamed: str);
					yourself]) asArray 	! !
